#include "SDL/SDL.h"
#include "GL/gl.h"
#include "math.h"
#include "iostream"
#include "fstream"
#include <stdio.h>
#include "lodepng.cpp"
//#include "eglport.c"
using namespace std;

 //::: Size of a pixel on Pandoras screen ("2"/800 = 0.0025 = X value) ("2" = openGL -1.0 to 1.0 screen space range)
 float pixel_to_gl_X = 0.0025, pixel_to_gl_Y = 0.004166667;

 //::::::::::::::::::::::::::::::::::: TEXTURE VARIABLES.
 const int nt1=21;//::::::::::::: MAX NUMBER OF TEXTURES.
 GLuint texture[nt1];const char* filename[nt1];unsigned error;unsigned char* image[nt1];
 unsigned int w[nt1], h[nt1];int w2[nt1],h2[nt1],tex_state=0;
 
 //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: STRUCTURE VARIABLES.
 int * tile;fstream myfile;int current_node=0,selt2,noldx[9999],noldy[9999],noldv[9999][3],selt[10];
 static float node[9999][6];float temptt,node_dist=0.0,ndt=0.0;static int sectord[2500][10][2];
 
 //:::::::::::: COUNTERS.
 int c=0,d=0,e=0,f=0,g=0;

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: ROTATION FUNCTION.
void rotate(float xp,float yp,float& ux,float& uy,float degrees){float bt,lx,ly,rx,ry,nnx,a;
if(uy<=yp&&ux>=xp){a=atan((yp-uy)/((ux-xp)))*57.295779579;lx=ux-xp;ly=yp-uy;}if(uy<=yp&&xp>ux)
{a=90.0+(90.0-acos((xp-ux)/(sqrt(((yp-uy)*(yp-uy))+((xp-ux)*(xp-ux)))))*57.295779579);lx=xp-ux;ly=yp-uy;}
if(yp<uy&&xp>ux){a=270.0-(90.0-(atan((uy-yp)/((xp-ux)))*57.295779579));lx=xp-ux;ly=uy-yp;}if(yp<uy&&ux>=xp)
{a=360.0-(acos((ux-xp)/(sqrt(((uy-yp)*(uy-yp))+((ux-xp)*(ux-xp)))))*57.295779579);lx=ux-xp;ly=uy-yp;}
a=((360.0-a)+degrees)+45.0;rx=cos(a*0.017453292)+sin(a*0.017453292);ry=-sin(a*0.017453292)+cos(a*0.017453292);
nnx=sqrt((rx*rx)+(ry*ry));bt=sqrt((lx*lx)+(ly*ly));rx/=nnx;ux=xp+(rx*bt);ry/=nnx;uy=yp-(ry*bt);}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: DYNAMIC DRAW.
void draw1(float posX, float posY, int width, int height, int texs, float scale, float rotation,
 float r, float g, float b, float a, float layer){
  float vd[18],td[12],cd[24],v1x,v1y,v2x,v2y,v3x,v3y,v4x,v4y;
  v1x=-width/2.0;v1y=-height/2.0;
  v2x= width/2.0;v2y=-height/2.0;
  v3x=-width/2.0;v3y= height/2.0;
  v4x= width/2.0;v4y= height/2.0;
  
  if(scale!=1.0){
  v1x*=scale;v1y*=scale;
  v2x*=scale;v2y*=scale;
  v3x*=scale;v3y*=scale;
  v4x*=scale;v4y*=scale;}
  
  if(rotation!=0.0){
  rotate(0.0,0.0,v1x,v1y,rotation);
  rotate(0.0,0.0,v2x,v2y,rotation);
  rotate(0.0,0.0,v3x,v3y,rotation);
  rotate(0.0,0.0,v4x,v4y,rotation);}
  
  v1x*=pixel_to_gl_X;v1y*=pixel_to_gl_Y;
  v2x*=pixel_to_gl_X;v2y*=pixel_to_gl_Y;
  v3x*=pixel_to_gl_X;v3y*=pixel_to_gl_Y;
  v4x*=pixel_to_gl_X;v4y*=pixel_to_gl_Y;
  
   vd[0]=posX+v1x;vd[1]=posY+v1y;vd[2]=layer;
   vd[3]=posX+v2x;vd[4]=posY+v2y;vd[5]=layer;
   vd[6]=posX+v3x;vd[7]=posY+v3y;vd[8]=layer;
   vd[9]= posX+v4x;vd[10]=posY+v4y;vd[11]=layer;
   vd[12]=posX+v3x;vd[13]=posY+v3y;vd[14]=layer;
   vd[15]=posX+v2x;vd[16]=posY+v2y;vd[17]=layer;
   td[0]=0.0; td[1]=1.0;
   td[2]=1.0; td[3]=1.0;
   td[4]=0.0; td[5]=0.0;
   td[6]=1.0; td[7]=0.0;
   td[8]=0.0; td[9]=0.0;
   td[10]=1.0;td[11]=1.0;
   cd[0]=r; cd[1]=g; cd[2]=b; cd[3]=a;
   cd[4]=r; cd[5]=g; cd[6]=b; cd[7]=a;
   cd[8]=r; cd[9]=g; cd[10]=b;cd[11]=a;
   cd[12]=r;cd[13]=g;cd[14]=b;cd[15]=a;
   cd[16]=r;cd[17]=g;cd[18]=b;cd[19]=a;
   cd[20]=r;cd[21]=g;cd[22]=b;cd[23]=a;
  glColorPointer(4,GL_FLOAT,0,cd);
  glTexCoordPointer(2,GL_FLOAT,0,td);
  glVertexPointer(3,GL_FLOAT,0,vd);
  glBindTexture(GL_TEXTURE_2D, texture[texs]);
  glDrawArrays(GL_TRIANGLES,0,6);}
  
//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: STATIC DRAW.
void draw2(float posX, float posY, int width, int height, int texs, float scale, float rotation,
 float r, float g, float b, float a, float layer){float vd[18],td[12],cd[24],v1x,v1y,v2x,v2y,v3x,v3y,v4x,v4y;
  v1x=width*pixel_to_gl_X;v1y=height*pixel_to_gl_Y;
   vd[0]=posX;     vd[1]=posY;     vd[2]=layer;
   vd[3]=posX+v1x; vd[4]=posY;     vd[5]=layer;
   vd[6]=posX;     vd[7]=posY+v1y; vd[8]=layer;
   vd[9]= posX+v1x;vd[10]=posY+v1y;vd[11]=layer;
   vd[12]=posX;    vd[13]=posY+v1y;vd[14]=layer;
   vd[15]=posX+v1x;vd[16]=posY;    vd[17]=layer;
   td[0]=0.0; td[1]=1.0;
   td[2]=1.0; td[3]=1.0;
   td[4]=0.0; td[5]=0.0;
   td[6]=1.0; td[7]=0.0;
   td[8]=0.0; td[9]=0.0;
   td[10]=1.0;td[11]=1.0;
   cd[0]=r; cd[1]=g; cd[2]=b; cd[3]=a;
   cd[4]=r; cd[5]=g; cd[6]=b; cd[7]=a;
   cd[8]=r; cd[9]=g; cd[10]=b;cd[11]=a;
   cd[12]=r;cd[13]=g;cd[14]=b;cd[15]=a;
   cd[16]=r;cd[17]=g;cd[18]=b;cd[19]=a;
   cd[20]=r;cd[21]=g;cd[22]=b;cd[23]=a;
  glColorPointer(4,GL_FLOAT,0,cd);
  glTexCoordPointer(2,GL_FLOAT,0,td);
  glVertexPointer(3,GL_FLOAT,0,vd);
  glBindTexture(GL_TEXTURE_2D, texture[texs]);
  glDrawArrays(GL_TRIANGLES,0,6);}

//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: DRAW LETTERS.
void draw3(float posX,float posY,int width,int height,char texs,float r,float g,float b,float a,float layer){
  float vd[18],td[12],cd[24],v1x,v1y,v2x,v2y,v3x,v3y,v4x,v4y,ld,lu,ll,lr;
  if(texs=='A'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=0.0*0.00390625;lr=8.0*0.00390625;}
  if(texs=='B'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=8.0*0.00390625;lr=16.0*0.00390625;}
  if(texs=='C'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=16.0*0.00390625;lr=24.0*0.00390625;}
  if(texs=='D'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=24.0*0.00390625;lr=32.0*0.00390625;}
  if(texs=='E'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=32.0*0.00390625;lr=40.0*0.00390625;}
  if(texs=='F'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=40.0*0.00390625;lr=48.0*0.00390625;}
  if(texs=='G'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=48.0*0.00390625;lr=56.0*0.00390625;}
  if(texs=='H'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=56.0*0.00390625;lr=64.0*0.00390625;}
  if(texs=='I'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=64.0*0.00390625;lr=72.0*0.00390625;}
  if(texs=='J'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=72.0*0.00390625;lr=80.0*0.00390625;}
  if(texs=='K'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=80.0*0.00390625;lr=88.0*0.00390625;}
  if(texs=='L'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=88.0*0.00390625;lr=96.0*0.00390625;}
  if(texs=='M'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=96.0*0.00390625;lr=108.0*0.00390625;}
  if(texs=='N'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=108.0*0.00390625;lr=118.0*0.00390625;}
  if(texs=='O'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=118.0*0.00390625;lr=126.0*0.00390625;}
  if(texs=='P'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=126.0*0.00390625;lr=134.0*0.00390625;}
  if(texs=='Q'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=134.0*0.00390625;lr=142.0*0.00390625;}
  if(texs=='R'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=142.0*0.00390625;lr=150.0*0.00390625;}
  if(texs=='S'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=150.0*0.00390625;lr=158.0*0.00390625;}
  if(texs=='T'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=158.0*0.00390625;lr=166.0*0.00390625;}
  if(texs=='U'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=166.0*0.00390625;lr=174.0*0.00390625;}
  if(texs=='V'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=174.0*0.00390625;lr=184.0*0.00390625;}
  if(texs=='W'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=184.0*0.00390625;lr=196.0*0.00390625;}
  if(texs=='X'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=196.0*0.00390625;lr=206.0*0.00390625;}
  if(texs=='Y'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=206.0*0.00390625;lr=214.0*0.00390625;}
  if(texs=='Z'){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=214.0*0.00390625;lr=222.0*0.00390625;}
  if(texs==' '){ld=0.0*0.00390625;lu=12.0*0.00390625;ll=222.0*0.00390625;lr=230.0*0.00390625;}
  if(texs=='0'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=0.0*0.00390625;lr=8.0*0.00390625;}
  if(texs=='1'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=8.0*0.00390625;lr=14.0*0.00390625;}
  if(texs=='2'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=14.0*0.00390625;lr=22.0*0.00390625;}
  if(texs=='3'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=22.0*0.00390625;lr=30.0*0.00390625;}
  if(texs=='4'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=30.0*0.00390625;lr=38.0*0.00390625;}
  if(texs=='5'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=38.0*0.00390625;lr=46.0*0.00390625;}
  if(texs=='6'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=46.0*0.00390625;lr=54.0*0.00390625;}
  if(texs=='7'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=54.0*0.00390625;lr=62.0*0.00390625;}
  if(texs=='8'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=62.0*0.00390625;lr=70.0*0.00390625;}
  if(texs=='9'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=70.0*0.00390625;lr=78.0*0.00390625;}
  if(texs=='!'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=78.0*0.00390625;lr=84.0*0.00390625;}
  if(texs=='?'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=84.0*0.00390625;lr=92.0*0.00390625;}
  if(texs=='.'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=92.0*0.00390625;lr=98.0*0.00390625;}
  if(texs==','){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=98.0*0.00390625;lr=104.0*0.00390625;}
  if(texs=='-'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=104.0*0.00390625;lr=112.0*0.00390625;}
  if(texs=='+'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=112.0*0.00390625;lr=120.0*0.00390625;}
  if(texs=='='){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=120.0*0.00390625;lr=128.0*0.00390625;}
  if(texs=='/'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=128.0*0.00390625;lr=136.0*0.00390625;}
  if(texs=='*'){ld=12.0*0.00390625;lu=24.0*0.00390625;ll=136.0*0.00390625;lr=144.0*0.00390625;}
  v1x=width*pixel_to_gl_X;v1y=height*pixel_to_gl_Y;
   vd[0]=posX;     vd[1]=posY;     vd[2]=layer;
   vd[3]=posX+v1x; vd[4]=posY;     vd[5]=layer;
   vd[6]=posX;     vd[7]=posY+v1y; vd[8]=layer;
   vd[9]= posX+v1x;vd[10]=posY+v1y;vd[11]=layer;
   vd[12]=posX;    vd[13]=posY+v1y;vd[14]=layer;
   vd[15]=posX+v1x;vd[16]=posY;    vd[17]=layer;
   td[0]=ll; td[1]=lu;
   td[2]=lr; td[3]=lu;
   td[4]=ll; td[5]=ld;
   td[6]=lr; td[7]=ld;
   td[8]=ll; td[9]=ld;
   td[10]=lr;td[11]=lu;
   cd[0]=r; cd[1]=g; cd[2]=b; cd[3]=a;
   cd[4]=r; cd[5]=g; cd[6]=b; cd[7]=a;
   cd[8]=r; cd[9]=g; cd[10]=b;cd[11]=a;
   cd[12]=r;cd[13]=g;cd[14]=b;cd[15]=a;
   cd[16]=r;cd[17]=g;cd[18]=b;cd[19]=a;
   cd[20]=r;cd[21]=g;cd[22]=b;cd[23]=a;
  glColorPointer(4,GL_FLOAT,0,cd);
  glTexCoordPointer(2,GL_FLOAT,0,td);
  glVertexPointer(3,GL_FLOAT,0,vd);
  glBindTexture(GL_TEXTURE_2D, texture[11]);
  glDrawArrays(GL_TRIANGLES,0,6);}

//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: DYNAMIC MIRROR DRAW.
void draw4(float posX, float posY, int width, int height, int texs, float scale, float rotation,
 float r, float g, float b, float a, float layer){
  float vd[18],td[12],cd[24],v1x,v1y,v2x,v2y,v3x,v3y,v4x,v4y;
  v1x=-width/2.0;v1y=-height/2.0;
  v2x= width/2.0;v2y=-height/2.0;
  v3x=-width/2.0;v3y= height/2.0;
  v4x= width/2.0;v4y= height/2.0;
  
  if(scale!=1.0){
  v1x*=scale;v1y*=scale;
  v2x*=scale;v2y*=scale;
  v3x*=scale;v3y*=scale;
  v4x*=scale;v4y*=scale;}
  
  if(rotation!=0.0){
  rotate(0.0,0.0,v1x,v1y,rotation);
  rotate(0.0,0.0,v2x,v2y,rotation);
  rotate(0.0,0.0,v3x,v3y,rotation);
  rotate(0.0,0.0,v4x,v4y,rotation);}
  
  v1x*=pixel_to_gl_X;v1y*=pixel_to_gl_Y;
  v2x*=pixel_to_gl_X;v2y*=pixel_to_gl_Y;
  v3x*=pixel_to_gl_X;v3y*=pixel_to_gl_Y;
  v4x*=pixel_to_gl_X;v4y*=pixel_to_gl_Y;
  
   vd[0]=posX+v1x;vd[1]=posY+v1y;vd[2]=layer;
   vd[3]=posX+v2x;vd[4]=posY+v2y;vd[5]=layer;
   vd[6]=posX+v3x;vd[7]=posY+v3y;vd[8]=layer;
   vd[9]= posX+v4x;vd[10]=posY+v4y;vd[11]=layer;
   vd[12]=posX+v3x;vd[13]=posY+v3y;vd[14]=layer;
   vd[15]=posX+v2x;vd[16]=posY+v2y;vd[17]=layer;
   td[0]=1.0; td[1]=1.0;
   td[2]=0.0; td[3]=1.0;
   td[4]=1.0; td[5]=0.0;
   td[6]=0.0; td[7]=0.0;
   td[8]=1.0; td[9]=0.0;
   td[10]=0.0;td[11]=1.0;
   cd[0]=r; cd[1]=g; cd[2]=b; cd[3]=a;
   cd[4]=r; cd[5]=g; cd[6]=b; cd[7]=a;
   cd[8]=r; cd[9]=g; cd[10]=b;cd[11]=a;
   cd[12]=r;cd[13]=g;cd[14]=b;cd[15]=a;
   cd[16]=r;cd[17]=g;cd[18]=b;cd[19]=a;
   cd[20]=r;cd[21]=g;cd[22]=b;cd[23]=a;
  glColorPointer(4,GL_FLOAT,0,cd);
  glTexCoordPointer(2,GL_FLOAT,0,td);
  glVertexPointer(3,GL_FLOAT,0,vd);
  glBindTexture(GL_TEXTURE_2D, texture[texs]);
  glDrawArrays(GL_TRIANGLES,0,6);}

void get_ani_frame(int ticks,int frames,float seconds,int& rv)//:::::::::::::::::::::::: GET FRAME FOR ANIMATION.
{float gf;char cf1[15],cf2[15];ticks=SDL_GetTicks()-ticks;
gf=(float)ticks/(seconds*1000.0);sprintf(cf1,"%f",gf);
for(int i=0;i<15;i++){if(cf1[i]=='.'){for(int j=0;j<3;j++){cf2[j]=cf1[i+j+1];}}}
gf=0.0;gf=atof(cf2);gf=(float)(gf*frames)/1000.0;rv=gf;}

//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: TEXTURE LOADING FUNCTION.
void load_textures(int level){//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  if(level==1){
  filename[0]="mechaf.png";
  filename[1]="mechau.png";
  filename[2]="mechad.png";
  filename[3]="cannonl.png";
  filename[4]="cannonr.png";
  filename[5]="cannonu.png";
  filename[6]="cannond.png";
  filename[7]="test2.png";
  filename[8]="test5.png";
  filename[9]="machine1.png";
  filename[10]="fire1.png";
  filename[11]="fatcar.png";
  filename[12]="texplotion1.png";
  filename[13]="texplotion2.png";
  filename[14]="texplotion3.png";
  filename[15]="texplotion4.png";
  filename[16]="texplotion5.png";
  filename[17]="texplotion6.png";
  filename[18]="texplotion7.png";
  filename[19]="texplotion8.png";
  filename[20]="fairy2.png";
   for(int i=0;i<nt1;i++){
    error = lodepng_decode32_file(&image[i], &w[i], &h[i], filename[i]);
    w2[i]=w[i];h2[i]=h[i];
    glGenTextures(1,&texture[i]);
  glBindTexture(GL_TEXTURE_2D, texture[i]);
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,w[i],h[i],0,
   GL_RGBA,GL_UNSIGNED_BYTE,image[i]);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);}
  myfile.open ("map3s.txt");//::::::::::::::::::::::::::::::: STRUCTURE
  myfile>>  selt2;
  tile = (int*) calloc (selt2*3,sizeof(int));
  while(c<10){
  myfile>>  selt[c];
  c+=1;}c=0;
  while(d<2500){while(e<10){
  myfile>>  sectord[d][e][0];
  myfile>>  sectord[d][e][1];
  e+=1;}e=0;d+=1;}d=0;
  while(c<9999){
  myfile>>  noldx[c];
  myfile>>  noldy[c];
  myfile>>  noldv[c][0];
  myfile>>  noldv[c][1];
  myfile>>  noldv[c][2];
  c+=1;}c=0;
  while(c<selt2*3){
  myfile>>  tile[c];
  c+=1;}c=0;
  myfile.close();
  while(c<9999){
    node[c][0]=noldx[c];
    node[c][1]=noldy[c];
    node[c][2]=noldx[c+1]-noldx[c];
    node[c][3]=noldy[c+1]-noldy[c];
    temptt=sqrt((node[c][2]*node[c][2])+(node[c][3]*node[c][3]));
    node[c][2]=(float)node[c][2]/temptt;
    node[c][3]=(float)node[c][3]/temptt;
    node[c][5]=temptt;
  node[c][4]=50.0/*noldv[c][2]*/;c+=1;}c=0;}//*************************** END LEVEL 1.
  if(level==2){
    
  }
tex_state=1;}

//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: CLEAN UP FUNCTION.
void free_textures(int level){//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  if(level==1){free (tile);
    for(int i=0;i<nt1;i++){
    free(image[i]);
    glDeleteTextures(1,&texture[i]);}}
  
}

//******************************************************************************************* MAIN STARTS HERE.
int main(){//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  float screen_width = 800, screen_height = 480;
  SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER);
//EGL_Open();
  //SDL_Surface* sl1=SDL_SetVideoMode(800,480,32,SDL_SWSURFACE|SDL_FULLSCREEN);
//EGL_Init();
  SDL_Surface* sl1=SDL_SetVideoMode(screen_width,screen_height,32,SDL_HWSURFACE|SDL_OPENGL|SDL_DOUBLEBUF);
  SDL_Event gameover;Uint8* key;
 glClearColor(0.0f,0.0f,0.0f,0.0f);
 glShadeModel(GL_SMOOTH);
 glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
 glEnable(GL_BLEND);
 glEnable(GL_TEXTURE_2D);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
 //glOrthof(-1.0,1.0,-1.0,1.0,1.0,1000000.0);
 glOrtho(-1.0,1.0,-1.0,1.0,1.0,1000000.0);
 glEnableClientState(GL_VERTEX_ARRAY);
 glEnableClientState(GL_TEXTURE_COORD_ARRAY);
 glEnableClientState(GL_COLOR_ARRAY);
 
 unsigned int oldTime=0,currentTime=0,framerate=16;// FRAMERATE LIMITER. 1000/16=62.5fps
 int end_level=0,level=1,quit=0;//:::::::::::::::::::: LEVEL VARIABLES. (plus QUIT)
 float play_time=0.0,timeval=1.0,ms;int cto,ctu,ptu;// TIME VARIABLES.
 int aim=0,aim_up=0,aim_down=0,pUP=0,pDOWN=0,pLEFT=0,pRIGHT=0;
 int shoota=0,shootap=0,shootab=0,shootabp=0;// PLAYER VARIABLES.
 int eds[10],ceds[10],eT;//::::::::::::::::::::::::::::::::::::::::::::::::::::::: SCREEN VARIABLES.
 float eX,eY,eS=1.0,eR=0.0,eRED=1.0,eGREEN=1.0,eBLUE=1.0,eALPHA=1.0,eDEPTH=-1.0,scrX=node[0][0],scrY=node[0][1];
 float tx,ty,old_scrX,old_scrY;int txi,tyi;// PROCESSING VARIABLES.
 int menu=0,menup=0,menac=0;float startx=-0.5,starty=0.0,endv,endt=0.0;char messt;// MENU VARIABLES.
 int sela=0,selb=0,pUPp=0,pDOWNp=0,pLEFTp=0,pRIGHTp=0,sub_menu=0,selectb=0,selectbb=0,selectbp=0,selectbbp=0,pos=1;
 int hit_exception=0,critical_exception=0,heX,heY,heT,beginning=1;
 
 static GLint T0=0,Frames=0;
 float vd2[18],td2[12],cd2[24];
  
  
//******************************************************************************************************* VALUES
float player_offset_X=-0.5;// POSITION PROCESSING AND INITIAL STARTING POSITION ON SCREEN.
float player_offset_Y=-0.8;// POSITION PROCESSING AND INITIAL STARTING POSITION ON SCREEN.
float player_speed=0.75,pls=player_speed;// 1.0 = half screen
float player_size_X=64.0,player_size_Y=64.0;int player_tex=0;// PROCESSING SIZE AND TEXTURE.
float player_position_X,player_position_Y,old_position_X,old_position_Y;
int player_death=0,player_death_ani=0,pdi=1;//(pdi = player direction, 1= face right, 0= face left)
float new_corner_upper_left_X,new_corner_upper_left_Y,new_corner_upper_right_X,new_corner_upper_right_Y;
float new_corner_lower_left_X,new_corner_lower_left_Y,new_corner_lower_right_X,new_corner_lower_right_Y;
float old_corner_upper_left_X,old_corner_upper_left_Y,old_corner_upper_right_X,old_corner_upper_right_Y;
float old_corner_lower_left_X,old_corner_lower_left_Y,old_corner_lower_right_X,old_corner_lower_right_Y;

const int nos=200;// MAX NUMBER OF SHOTS THAT CAN EXCIST SIMULTANEOUSLY.
float fire[nos][4],fire_speed=400.0,fst=fire_speed,dfau=0.4,fau=dfau,dfas=0.75,fas=dfas;
while(c<nos){
  fire[c][0]=-999;// X POSITION
  fire[c][1]=0;// Y POSITION
  fire[c][2]=0;// SPEED OF TRAVEL X
  fire[c][3]=0;// SPEED OF TRAVEL Y
c+=1;}c=0;

int ne_fairy=2;
float fairy_f[ne_fairy][6];
fairy_f[c][0]=200.0;// X STARTING POSITION
fairy_f[c][1]=40.0;// Y STARTING POSITION
fairy_f[c][2]=0.0;// DYNAMIC X POSITION
fairy_f[c][3]=0.0;// DYNAMIC Y POSITION
fairy_f[c][4]=0.0;// SINE TIME VALUE
fairy_f[c][5]=1.0;// DIRECTION (-1.0 = right to left, 1.0 = left to right)


fairy_f[1][0]=1200.0;// X STARTING POSITION
fairy_f[1][1]=40.0;// Y STARTING POSITION
fairy_f[1][2]=0.0;// DYNAMIC X POSITION
fairy_f[1][3]=0.0;// DYNAMIC Y POSITION
fairy_f[1][4]=0.0;// SINE TIME VALUE
fairy_f[1][5]=-1.0;// DIRECTION (-1.0 = right to left, 1.0 = left to right)

int fairy_i[ne_fairy][4];
fairy_i[c][0]=1;// HITPOINTS
fairy_i[c][1]=0;// ANIMATION STARTING TIME
fairy_i[c][2]=0;// DEATH ANIMATION STARTING TIME
fairy_i[c][3]=0;// ACTIVE? (1=YES, 0=NO)


fairy_i[1][0]=1;// HITPOINTS
fairy_i[1][1]=0;// ANIMATION STARTING TIME
fairy_i[1][2]=0;// DEATH ANIMATION STARTING TIME
fairy_i[1][3]=0;// ACTIVE? (1=YES, 0=NO)

float fairy_sine_height=24.0 ;//* pixel_to_gl_Y;// TOTAL DIFFERENCE IN HEIGHT (in pixels)
float fairy_sine_speed=5.0;// SPEED OF MOVING UP/DOWN
float fairy_speed=130.0;// SPEED OF MOVING FOWARDS (in GL per second, one screen = 2.0 GL)
int fairy_width=32;// WIDTH OF ENEMY PHYSICS
int fairy_height=32;// HEIGHT OF ENEMY PHYSICS
int fairy_first_frame=20;// FIRST FRAME FOR ANIMATION (in texture number)
int fairy_first_death=12;// FIRST FRAME FOR DEATH ANIMATION
int fairy_number_frames=1;// NUMBER OF FRAMES FOR ANIMATION
int fairy_number_death=8;// NUMBER OF FRAMES FOR DEATH ANIMATION
float fairy_alenght=2.0;// ANIMATION LENGHT (1.0 = 1 second)
float fairy_dlenght=2.0;// DEATH ANIMATION LENGHT







float parralax_speed[10];// SPEED OF SCROLLING LAYERS.
parralax_speed[0]=0.0;// FURTHEST IN LAYER
parralax_speed[1]=0.2;
parralax_speed[2]=0.35;
parralax_speed[3]=0.5;
parralax_speed[4]=0.65;
parralax_speed[5]=0.8;
parralax_speed[6]=1.0;// MAIN LAYER
parralax_speed[7]=1.0;
parralax_speed[8]=1.4;
parralax_speed[9]=1.8;// NEAREST LAYER

float screen_layer[10][3];
while(c<10){
  screen_layer[c][0]=0.0;// X POSITION OF LAYER
  screen_layer[c][1]=0.0;// Y POSITION OF LAYER
  screen_layer[c][2]=parralax_speed[c];// SPEED OF SCROLL (in relation to layer 6 (standard layer))
c+=1;}c=0;

char * messp;
char mess1[] = "ADJUST FIRE ANGLE";
char mess2[] = "UP VALUE";// WHAT THE BLOODY FUCK????!!!! this array is empty.... WHY???!!!
char mess11[] = "UP VALUE";
char mess3[] = "SIDE VALUE";
char mess4[] = "ADJUST FIRE SPEED";
char mess5[] = "ADJUST PLAYER SPEED";
char mess6[] = "I LOVE VIDEOGAMES!!!1";
char mess7[10];sprintf(mess7,"%f",dfas);
char mess8[10];sprintf(mess8,"%f",dfau);
char mess9[10];sprintf(mess9,"%f",player_speed);
char mess10[10];sprintf(mess10,"%f",fire_speed);

myfile.open ("data.txt");
myfile>>  player_speed;pls=player_speed;
myfile>>  fire_speed;fst=fire_speed;
myfile>>  dfau;fau=dfau;
myfile>>  dfas;fas=dfas;
myfile.close();

cout<<mess8<<endl;
  
  //  GAME LOOP STARTS HERE **************************************
while(quit==0){while(SDL_PollEvent(&gameover))
{if(gameover.type==SDL_QUIT){quit=1;}}

 key=SDL_GetKeyState(NULL);  //       CONTROLS
 if(key[SDLK_ESCAPE]){quit=1;}
 
 if(level==0){
 
 if(key[SDLK_UP]){}
 if(key[SDLK_DOWN]){}
 if(key[SDLK_LEFT]){}
 if(key[SDLK_RIGHT]){}
 if(key[SDLK_a]){}
 if(key[SDLK_z]){}
 if(key[SDLK_q]){}
 if(key[SDLK_e]){}
 if(key[SDLK_w]){}
 if(key[SDLK_s]){}
 if(key[SDLK_x]){}
 if(key[SDLK_i]){}
 if(key[SDLK_o]){}
 if(key[SDLK_p]){}
 if(key[SDLK_k]){}
 if(key[SDLK_l]){}
 if(key[SDLK_j]){}// END OF CONTROLS
 
 glClear(GL_COLOR_BUFFER_BIT);

 

    
 }//****************************************************************** END OF LEVEL 0
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
  if(level==1){if(tex_state==0){load_textures(1);ctu=SDL_GetTicks();}//************************** START OF LEVEL 1.
 
 if(key[SDLK_SPACE]){menu=1;}else{menup=0;}

 
 
 if(key[SDLK_a]){}

 
 if(key[SDLK_q]){end_level=1;}
 if(key[SDLK_e]){}
 if(key[SDLK_w]){}
 if(key[SDLK_s]){}
 if(key[SDLK_x]){}
 if(key[SDLK_i]){}
 if(key[SDLK_o]){}
 if(key[SDLK_p]){}
 if(key[SDLK_k]){}
 if(key[SDLK_l]){}
 if(key[SDLK_j]){}// END OF CONTROLS







if(menu==1&&menup==0){if(menac==1){menac=0;}else{menac=1;}menup=1;}menu=0;
  
if(menac==1){
 if(key[SDLK_UP]){pUP=1;}else{pUPp=0;}
 if(key[SDLK_DOWN]){pDOWN=1;}else{pDOWNp=0;}
 if(key[SDLK_LEFT]){pLEFT=1;}else{pLEFTp=0;}
 if(key[SDLK_RIGHT]){pRIGHT=1;}else{pRIGHTp=0;}
 if(key[SDLK_PAGEDOWN]){selectb=1;}else{selectbp=0;}
 if(key[SDLK_PAGEUP]){selectbb=1;}else{selectbbp=0;}
 
 if(selectb==1&&selectbp==0){sela=1;selectbp=1;}selectb=0;
 if(selectbb==1&&selectbbp==0){selb=1;selectbbp=1;}selectbb=0;
  
 
  if(sub_menu==11){// SIDE VALUE (ANGLE OF FIRE)
    if(selb==1){sub_menu=1;sela=0;selb=0;pos=1;}
    if(sela==1){sub_menu=1;dfas=fas;sprintf(mess7,"%f",fas);sela=0;selb=0;}
    if(pUP==1&&pUPp==0){fas+=0.05;if(fas>1.0){fas=1.0;}sprintf(mess7,"%f",fas);pUPp=1;}pUP=0;
    if(pDOWN==1&&pDOWNp==0){fas-=0.05;if(fas<0.0){fas=0.0;}sprintf(mess7,"%f",fas);pDOWNp=1;}pDOWN=0;}
 
  if(sub_menu==10){// UP VALUE (ANGLE OF FIRE)
    if(selb==1){sub_menu=1;sela=0;selb=0;pos=1;}
    if(sela==1){sub_menu=1;dfau=fau;sprintf(mess8,"%f",fau);sela=0;selb=0;}
    if(pUP==1&&pUPp==0){fau+=0.05;if(fau>1.0){fau=1.0;}sprintf(mess8,"%f",fau);pUPp=1;}pUP=0;
    if(pDOWN==1&&pDOWNp==0){fau-=0.05;if(fau<0.0){fau=0.0;}sprintf(mess8,"%f",fau);pDOWNp=1;}pDOWN=0;}
 
  if(sub_menu==3){// PLAYER SPEED
    if(sela==1){sub_menu=0;pos=1;player_speed=pls;sprintf(mess9,"%f",pls);sela=0;selb=0;}
    if(selb==1){sub_menu=0;pos=1;sela=0;selb=0;}
    if(pUP==1&&pUPp==0){pls+=0.05;if(pls>20.0){pls=20.0;}sprintf(mess9,"%f",pls);pUPp=1;}pUP=0;
    if(pDOWN==1&&pDOWNp==0){pls-=0.05;if(pls<0.0){pls=0.0;}sprintf(mess9,"%f",pls);pDOWNp=1;}pDOWN=0;}
 
  if(sub_menu==2){// FIRE SPEED
    if(sela==1){sub_menu=0;pos=1;fire_speed=fst;sprintf(mess10,"%f",fst);sela=0;selb=0;}
    if(selb==1){sub_menu=0;pos=1;sela=0;selb=0;}
    if(pUP==1){fst+=10.0;if(fst>10000.0){fst=10000.0;}sprintf(mess10,"%f",fst);}pUP=0;
    if(pDOWN==1){fst-=10.0;if(fst<0.0){fst=0.0;}sprintf(mess10,"%f",fst);}pDOWN=0;}
 
  if(sub_menu==1){// ADJUST FIRE ANGLE
    if(sela==1){if(pos==1){sub_menu=10;sela=0;selb=0;}else{sub_menu=11;sela=0;selb=0;}}
    if(selb==1){sub_menu=0;pos=1;sela=0;selb=0;}
    if(pUP==1&&pUPp==0){pos-=1;if(pos<1){pos=1;}pUPp=1;}pUP=0;
    if(pDOWN==1&&pDOWNp==0){pos+=1;if(pos>2){pos=2;}pDOWNp=1;}pDOWN=0;}
    
  if(sub_menu==0){
    if(sela==1){sub_menu=pos;sela=0;selb=0;}
    if(pUP==1&&pUPp==0){pos-=1;if(pos<1){pos=1;}pUPp=1;}pUP=0;
    if(pDOWN==1&&pDOWNp==0){pos+=1;if(pos>3){pos=3;}pDOWNp=1;}pDOWN=0;}
  
  
}else{
 if(key[SDLK_UP]){pUP=1;}else{pUP=0;}
 if(key[SDLK_DOWN]){pDOWN=1;}else{pDOWN=0;}
 if(key[SDLK_LEFT]){pLEFT=1;}else{pLEFT=0;}
 if(key[SDLK_RIGHT]){pRIGHT=1;}else{pRIGHT=0;}
 if(key[SDLK_END]){shoota=1;}else{shootap=0;}
 if(key[SDLK_HOME]){shootab=1;}else{shootabp=0;}
 if(key[SDLK_RSHIFT]){aim_up=1;}else{aim_up=0;}
 if(key[SDLK_RCTRL]){aim_down=1;}else{aim_down=0;}
}
  sela=0;selb=0;
  




if(menac==1){timeval=0.0;}else{timeval=1.0;}
cto=ctu;ctu=SDL_GetTicks();ptu=ctu-cto;ms=(float)ptu/1000;// DYNAMIC FRAMERATE CALCULATION
     play_time=timeval*ms;// UPDATE GAME TIME VALUES
     

   old_position_X=player_position_X;
   old_position_Y=player_position_Y;
   old_scrX=scrX;
   old_scrY=scrY;

  //:::::::::::::::::::: UPDATE SCREEN SCROLL POSITION.
  if(node[current_node+1][0]!=0.0||node[current_node+1][1]!=0.0){
  ndt+=node[current_node][4]*play_time;tx=ndt-node_dist;
  while(tx>node[current_node][5]){tx-=node[current_node][5];
   node_dist+=node[current_node][5];current_node+=1;}
  scrX=node[current_node][0]+((ndt-node_dist)*node[current_node][2])-0;
  scrY=node[current_node][1]+((ndt-node_dist)*node[current_node][3])-240.0;
  while(c<10){
   screen_layer[c][0]=scrX*screen_layer[c][2];
   screen_layer[c][1]=scrY*screen_layer[c][2];
  c+=1;}c=0;}
  //cout<<screen_layer[1][0]<<"   "<<screen_layer[3][0]<<endl;
  
  //::::::::::::::::::::::::::::::::::::::::::: UPDATE PLAYER POSITION.
  if(beginning!=1){
  player_offset_X=((player_position_X-scrX+(scrX-old_scrX))*pixel_to_gl_X)-1.0;
  player_offset_Y=((player_position_Y-scrY+(scrY-old_scrY))*pixel_to_gl_Y)-1.0;}beginning=0;
  if(pUP==1){player_offset_Y+=player_speed*play_time;}
  if(pDOWN==1){player_offset_Y-=player_speed*play_time;}
  if(pLEFT==1){player_offset_X-=player_speed*(screen_height/screen_width)*play_time;}
  if(pRIGHT==1){player_offset_X+=player_speed*(screen_height/screen_width)*play_time;}
    if(player_offset_X<-0.94){player_offset_X=-0.94;}
    if(player_offset_X>0.94){player_offset_X=0.94;}
    if(player_offset_Y<-0.94){player_offset_Y=-0.94;}
    if(player_offset_Y>0.94){player_offset_Y=0.94;}
   player_position_X=scrX+((player_offset_X+1.0)*(screen_width/2.0));
   player_position_Y=scrY+((player_offset_Y+1.0)*(screen_height/2.0));
   //cout<<player_position_X<<endl;
//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: GET THE DYNAMIC LOADING ARRAY SLOT VALUE.
float hmm;
while(c<10){
hmm=(float)screen_layer[c][1]/480.0;e=hmm;hmm=(float)screen_layer[c][0]/800.0;d=hmm;eds[c]=e+(d*50)+25;
c+=1;}c=0;d=0;e=0;
  
  
int ur,ul,lr,ll,tur,tul,tlr,tll;ur=0;ul=0;lr=0;ll=0;tur=0;tul=0;tlr=0;tll=0;d=6;//:::::::::::: COLLISION DETECTION.
if(eds[d]-51>-1){
   while(c<sectord[eds[d]-51][d][0]&&sectord[eds[d]-51][d][0]>0){
     eX=tile[(sectord[eds[d]-51][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]-51][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]-51][d][1]+(c*3))+2];
  if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
   
     if(ur==1&&lr==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     if(ur==1&&ul==1){player_position_Y=eY-(player_size_Y/2.0)-1.0;}
     if(lr==1&&ll==1){player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}
     if(ul==1&&ll==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     
     
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tur=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tul=1;}
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tlr=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tll=1;}
     
     if(tur==1&&tlr==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     if(tur==1&&tul==1){player_position_Y=(eY+h2[eT])+(player_size_Y/2.0)+1.0;}
     if(tlr==1&&tll==1){player_position_Y=eY-(player_size_X/2.0)-1.0;}
     if(tul==1&&tll==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     ur=0;ul=0;lr=0;ll=0;tur=0;tul=0;tlr=0;tll=0;
  c+=1;}c=0;}
if(eds[d]-50>-1){
   while(c<sectord[eds[d]-50][d][0]&&sectord[eds[d]-50][d][0]>0){
     eX=tile[(sectord[eds[d]-50][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]-50][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]-50][d][1]+(c*3))+2];
  if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
   
     if(ur==1&&lr==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     if(ur==1&&ul==1){player_position_Y=eY-(player_size_Y/2.0)-1.0;}
     if(lr==1&&ll==1){player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}
     if(ul==1&&ll==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}

     
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tur=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tul=1;}
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tlr=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tll=1;}
     
     if(tur==1&&tlr==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     if(tur==1&&tul==1){player_position_Y=(eY+h2[eT])+(player_size_Y/2.0)+1.0;}
     if(tlr==1&&tll==1){player_position_Y=eY-(player_size_X/2.0)-1.0;}
     if(tul==1&&tll==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     ur=0;ul=0;lr=0;ll=0;tur=0;tul=0;tlr=0;tll=0;
  c+=1;}c=0;}
if(eds[d]-49>-1){
   while(c<sectord[eds[d]-49][d][0]&&sectord[eds[d]-49][d][0]>0){
     eX=tile[(sectord[eds[d]-49][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]-49][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]-49][d][1]+(c*3))+2];
  if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
   
     if(ur==1&&lr==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     if(ur==1&&ul==1){player_position_Y=eY-(player_size_Y/2.0)-1.0;}
     if(lr==1&&ll==1){player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}
     if(ul==1&&ll==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     
     
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tur=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tul=1;}
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tlr=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tll=1;}
     
     if(tur==1&&tlr==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     if(tur==1&&tul==1){player_position_Y=(eY+h2[eT])+(player_size_Y/2.0)+1.0;}
     if(tlr==1&&tll==1){player_position_Y=eY-(player_size_X/2.0)-1.0;}
     if(tul==1&&tll==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     ur=0;ul=0;lr=0;ll=0;tur=0;tul=0;tlr=0;tll=0;
  c+=1;}c=0;}
if(eds[d]-1>-1){
   while(c<sectord[eds[d]-1][d][0]&&sectord[eds[d]-1][d][0]>0){
     eX=tile[(sectord[eds[d]-1][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]-1][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]-1][d][1]+(c*3))+2];
   if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
   
     if(ur==1&&lr==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     if(ur==1&&ul==1){player_position_Y=eY-(player_size_Y/2.0)-1.0;}
     if(lr==1&&ll==1){player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}
     if(ul==1&&ll==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     
     
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tur=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tul=1;}
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tlr=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tll=1;}
     
     if(tur==1&&tlr==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     if(tur==1&&tul==1){player_position_Y=(eY+h2[eT])+(player_size_Y/2.0)+1.0;}
     if(tlr==1&&tll==1){player_position_Y=eY-(player_size_X/2.0)-1.0;}
     if(tul==1&&tll==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     ur=0;ul=0;lr=0;ll=0;tur=0;tul=0;tlr=0;tll=0;
  c+=1;}c=0;}
   while(c<sectord[eds[d]][d][0]&&sectord[eds[d]][d][0]>0){//******************************************************
     eX=tile[(sectord[eds[d]][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]][d][1]+(c*3))+2];
   if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
   
     if(ur==1&&lr==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     if(ur==1&&ul==1){player_position_Y=eY-(player_size_Y/2.0)-1.0;}
     if(lr==1&&ll==1){player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}
     if(ul==1&&ll==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     
     
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tur=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tul=1;}
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tlr=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tll=1;}
     
     if(tur==1&&tlr==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     if(tur==1&&tul==1){player_position_Y=(eY+h2[eT])+(player_size_Y/2.0)+1.0;}
     if(tlr==1&&tll==1){player_position_Y=eY-(player_size_X/2.0)-1.0;}
     if(tul==1&&tll==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     ur=0;ul=0;lr=0;ll=0;tur=0;tul=0;tlr=0;tll=0;
   
  c+=1;}c=0;
if(eds[d]+1<2500){//************************************************************************************************
   while(c<sectord[eds[d]+1][d][0]&&sectord[eds[d]+1][d][0]>0){
     eX=tile[(sectord[eds[d]+1][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]+1][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]+1][d][1]+(c*3))+2];
  if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
   
     if(ur==1&&lr==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     if(ur==1&&ul==1){player_position_Y=eY-(player_size_Y/2.0)-1.0;}
     if(lr==1&&ll==1){player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}
     if(ul==1&&ll==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     
     
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tur=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tul=1;}
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tlr=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tll=1;}
     
     if(tur==1&&tlr==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     if(tur==1&&tul==1){player_position_Y=(eY+h2[eT])+(player_size_Y/2.0)+1.0;}
     if(tlr==1&&tll==1){player_position_Y=eY-(player_size_X/2.0)-1.0;}
     if(tul==1&&tll==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     ur=0;ul=0;lr=0;ll=0;tur=0;tul=0;tlr=0;tll=0;
  c+=1;}c=0;}
if(eds[d]+49<2500){
   while(c<sectord[eds[d]+49][d][0]&&sectord[eds[d]+49][d][0]>0){
     eX=tile[(sectord[eds[d]+49][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]+49][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]+49][d][1]+(c*3))+2];
  if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
   
     if(ur==1&&lr==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     if(ur==1&&ul==1){player_position_Y=eY-(player_size_Y/2.0)-1.0;}
     if(lr==1&&ll==1){player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}
     if(ul==1&&ll==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     
     
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tur=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tul=1;}
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tlr=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tll=1;}
     
     if(tur==1&&tlr==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     if(tur==1&&tul==1){player_position_Y=(eY+h2[eT])+(player_size_Y/2.0)+1.0;}
     if(tlr==1&&tll==1){player_position_Y=eY-(player_size_X/2.0)-1.0;}
     if(tul==1&&tll==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     ur=0;ul=0;lr=0;ll=0;tur=0;tul=0;tlr=0;tll=0;
  c+=1;}c=0;}
if(eds[d]+50<2500){
   while(c<sectord[eds[d]+50][d][0]&&sectord[eds[d]+50][d][0]>0){
     eX=tile[(sectord[eds[d]+50][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]+50][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]+50][d][1]+(c*3))+2];
  if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
   
     if(ur==1&&lr==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     if(ur==1&&ul==1){player_position_Y=eY-(player_size_Y/2.0)-1.0;}
     if(lr==1&&ll==1){player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}
     if(ul==1&&ll==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     
     
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tur=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tul=1;}
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tlr=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tll=1;}
     
     if(tur==1&&tlr==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     if(tur==1&&tul==1){player_position_Y=(eY+h2[eT])+(player_size_Y/2.0)+1.0;}
     if(tlr==1&&tll==1){player_position_Y=eY-(player_size_X/2.0)-1.0;}
     if(tul==1&&tll==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     ur=0;ul=0;lr=0;ll=0;tur=0;tul=0;tlr=0;tll=0;
  c+=1;}c=0;}
if(eds[d]+51<2500){
   while(c<sectord[eds[d]+51][d][0]&&sectord[eds[d]+51][d][0]>0){
     eX=tile[(sectord[eds[d]+51][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]+51][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]+51][d][1]+(c*3))+2];
  if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
   
     if(ur==1&&lr==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     if(ur==1&&ul==1){player_position_Y=eY-(player_size_Y/2.0)-1.0;}
     if(lr==1&&ll==1){player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}
     if(ul==1&&ll==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     
     
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tur=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tul=1;}
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tlr=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tll=1;}
     
     if(tur==1&&tlr==1){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
     if(tur==1&&tul==1){player_position_Y=(eY+h2[eT])+(player_size_Y/2.0)+1.0;}
     if(tlr==1&&tll==1){player_position_Y=eY-(player_size_X/2.0)-1.0;}
     if(tul==1&&tll==1){player_position_X=eX-(player_size_X/2.0)-1.0;}
     ur=0;ul=0;lr=0;ll=0;tur=0;tul=0;tlr=0;tll=0;
  c+=1;}c=0;}d=0;

  
  
  
  d=6;
if(eds[d]-51>-1){
   while(c<sectord[eds[d]-51][d][0]&&sectord[eds[d]-51][d][0]>0){
     eX=tile[(sectord[eds[d]-51][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]-51][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]-51][d][1]+(c*3))+2];
  if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
     
     if(ur==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(ul==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(lr==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
     if(ll==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
       ur=0;ul=0;lr=0;ll=0;
  c+=1;}c=0;}
if(eds[d]-50>-1){
   while(c<sectord[eds[d]-50][d][0]&&sectord[eds[d]-50][d][0]>0){
     eX=tile[(sectord[eds[d]-50][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]-50][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]-50][d][1]+(c*3))+2];
  if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
     
     if(ur==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(ul==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(lr==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
     if(ll==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
       ur=0;ul=0;lr=0;ll=0;
  c+=1;}c=0;}
if(eds[d]-49>-1){
   while(c<sectord[eds[d]-49][d][0]&&sectord[eds[d]-49][d][0]>0){
     eX=tile[(sectord[eds[d]-49][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]-49][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]-49][d][1]+(c*3))+2];
  if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
     
     if(ur==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(ul==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(lr==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
     if(ll==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
       ur=0;ul=0;lr=0;ll=0;
  c+=1;}c=0;}
if(eds[d]-1>-1){
   while(c<sectord[eds[d]-1][d][0]&&sectord[eds[d]-1][d][0]>0){
     eX=tile[(sectord[eds[d]-1][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]-1][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]-1][d][1]+(c*3))+2];
   if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
     
     if(ur==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(ul==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(lr==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
     if(ll==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
       ur=0;ul=0;lr=0;ll=0;
  c+=1;}c=0;}
   while(c<sectord[eds[d]][d][0]&&sectord[eds[d]][d][0]>0){//******************************************************
     eX=tile[(sectord[eds[d]][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]][d][1]+(c*3))+2];
   if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
     
     if(ur==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(ul==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(lr==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
     if(ll==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
   ur=0;ul=0;lr=0;ll=0;
  c+=1;}c=0;
if(eds[d]+1<2500){//************************************************************************************************
   while(c<sectord[eds[d]+1][d][0]&&sectord[eds[d]+1][d][0]>0){
     eX=tile[(sectord[eds[d]+1][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]+1][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]+1][d][1]+(c*3))+2];
  if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
     
     if(ur==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(ul==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(lr==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
     if(ll==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
       ur=0;ul=0;lr=0;ll=0;
  c+=1;}c=0;}
if(eds[d]+49<2500){
   while(c<sectord[eds[d]+49][d][0]&&sectord[eds[d]+49][d][0]>0){
     eX=tile[(sectord[eds[d]+49][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]+49][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]+49][d][1]+(c*3))+2];
  if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
     
     if(ur==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(ul==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(lr==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
     if(ll==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
       ur=0;ul=0;lr=0;ll=0;
  c+=1;}c=0;}
if(eds[d]+50<2500){
   while(c<sectord[eds[d]+50][d][0]&&sectord[eds[d]+50][d][0]>0){
     eX=tile[(sectord[eds[d]+50][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]+50][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]+50][d][1]+(c*3))+2];
  if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
     
     if(ur==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(ul==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(lr==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
     if(ll==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
       ur=0;ul=0;lr=0;ll=0;
  c+=1;}c=0;}
if(eds[d]+51<2500){
   while(c<sectord[eds[d]+51][d][0]&&sectord[eds[d]+51][d][0]>0){
     eX=tile[(sectord[eds[d]+51][d][1]+(c*3))+0]+400;
     eY=tile[(sectord[eds[d]+51][d][1]+(c*3))+1]+240;
     eT=tile[(sectord[eds[d]+51][d][1]+(c*3))+2];
  if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
     
     if(ur==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(ul==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(player_position_Y+(player_size_Y/2.0))-eY;
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=eY-(player_size_X/2.0)-1.0;}}
     if(lr==1){
       tx=(player_position_X+(player_size_X/2.0))-eX;
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=eX-(player_size_X/2.0)-1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
     if(ll==1){
       tx=(eX+w2[eT])-(player_position_X-(player_size_X/2.0));
       ty=(eY+h2[eT])-(player_position_Y-(player_size_Y/2.0));
       if(tx<=ty){player_position_X=(eX+w2[eT])+(player_size_X/2.0)+1.0;}
       else{player_position_Y=(eY+h2[eT])+(player_size_X/2.0)+1.0;}}
       ur=0;ul=0;lr=0;ll=0;
  c+=1;}c=0;}d=0;//******************************************************************* END OF COLLISION DETECTION.
  
  //if(player_position_X<-0.95||player_position_X>0.95||player_position_Y<-0.95||player_position_Y>0.95)
  if(((player_position_X-scrX+(scrX-old_scrX))*pixel_to_gl_X)-1.0<-0.95||
     ((player_position_X-scrX+(scrX-old_scrX))*pixel_to_gl_X)-1.0>0.95||
     ((player_position_Y-scrY+(scrY-old_scrY))*pixel_to_gl_Y)-1.0<-0.95||
     ((player_position_Y-scrY+(scrY-old_scrY))*pixel_to_gl_Y)-1.0>0.95)
  {if(player_death==0){player_death=1;player_death_ani=SDL_GetTicks();}}
  
  
  
  
   
   
   


//:::::::::::::::::::::::::::::::: UPDATE AIM DIRECTION.
if(aim_up==1&&aim_down==0){aim=0;}
if(aim_up==0&&aim_down==1){aim=2;}
if(aim_up==1&&aim_down==1){aim=1;}
if(aim_up==0&&aim_down==0){aim=1;}
while(c<nos){//:::::::::: UPDATE PLAYER SHOTS POSITIONS.
 if(fire[c][0]!=-999.0){
 tx=(float)fire[c][2]*play_time;
 ty=(float)fire[c][3]*play_time;
 fire[c][0]+=tx+(player_position_X-old_position_X);
 fire[c][1]+=ty+(player_position_Y-old_position_Y);}
c+=1;}c=0;
//:::::::::::: IF FIRE BUTTON WAS PRESSED GENERATE SHOT.
if(shoota==1&&shootap==0&&menu==0){
 while(d<1){
   if(fire[c][0]==-999.0){
 fire[c][0]=player_position_X;
 fire[c][1]=player_position_Y;
 if(aim==0){// DIAGONALLY UP
   fire[c][2]=fire_speed*dfas;
   fire[c][3]=-fire_speed*dfau;}
 if(aim==1){// FORWARD
   fire[c][2]=fire_speed;
   fire[c][3]=0;}
 if(aim==2){// DIAGONALLY DOWN
   fire[c][2]=fire_speed*dfas;
   fire[c][3]=fire_speed*dfau;}
   d=1;}
 if(c>nos){d=1;}c+=1;}c=0;d=0;
pdi=1;shootap=1;}shoota=0;
if(shootab==1&&shootabp==0&&menu==0){
 while(d<1){
   if(fire[c][0]==-999.0){
 fire[c][0]=player_position_X;
 fire[c][1]=player_position_Y;
 if(aim==0){// DIAGONALLY UP
   fire[c][2]=(fire_speed*dfas)*-1.0;
   fire[c][3]=-fire_speed*dfau;}
 if(aim==1){// FORWARD
   fire[c][2]=fire_speed*-1.0;
   fire[c][3]=0;}
 if(aim==2){// DIAGONALLY DOWN
   fire[c][2]=(fire_speed*dfas)*-1.0;
   fire[c][3]=fire_speed*dfau;}
   d=1;}
 if(c>nos){d=1;}c+=1;}c=0;d=0;
pdi=0;shootabp=1;}shootab=0;



//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: DRAW TILE MAP.
eS=1.0;eR=0.0;eRED=1.0;eGREEN=1.0;eBLUE=1.0;eALPHA=1.0;
  while(d<7){
   if(eds[d]-51>-1){
   while(c<sectord[eds[d]-51][d][0]&&sectord[eds[d]-51][d][0]>0){
     eX=(tile[(sectord[eds[d]-51][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]-51][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]-51][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
   if(eds[d]-50>-1){
   while(c<sectord[eds[d]-50][d][0]&&sectord[eds[d]-50][d][0]>0){
     eX=(tile[(sectord[eds[d]-50][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]-50][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]-50][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
   if(eds[d]-49>-1){
   while(c<sectord[eds[d]-49][d][0]&&sectord[eds[d]-49][d][0]>0){
     eX=(tile[(sectord[eds[d]-49][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]-49][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]-49][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
   if(eds[d]-1>-1){
   while(c<sectord[eds[d]-1][d][0]&&sectord[eds[d]-1][d][0]>0){
     eX=(tile[(sectord[eds[d]-1][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]-1][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]-1][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
   while(c<sectord[eds[d]][d][0]&&sectord[eds[d]][d][0]>0){
     eX=(tile[(sectord[eds[d]][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;
   if(eds[d]+1<2500){
   while(c<sectord[eds[d]+1][d][0]&&sectord[eds[d]+1][d][0]>0){
     eX=(tile[(sectord[eds[d]+1][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]+1][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]+1][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
   if(eds[d]+49<2500){
   while(c<sectord[eds[d]+49][d][0]&&sectord[eds[d]+49][d][0]>0){
     eX=(tile[(sectord[eds[d]+49][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]+49][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]+49][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
   if(eds[d]+50<2500){
   while(c<sectord[eds[d]+50][d][0]&&sectord[eds[d]+50][d][0]>0){
     eX=(tile[(sectord[eds[d]+50][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]+50][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]+50][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
   if(eds[d]+51<2500){
   while(c<sectord[eds[d]+51][d][0]&&sectord[eds[d]+51][d][0]>0){
     eX=(tile[(sectord[eds[d]+51][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]+51][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]+51][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
  d+=1;}d=0;e=0;


  
  
while(c<nos){if(fire[c][0]!=-999.0){//:::::::::::: DRAW PLAYER SHOTS.
  tx=(float)((fire[c][0]-scrX)*pixel_to_gl_X)-1.0;
  ty=(float)((fire[c][1]-scrY)*pixel_to_gl_Y)-1.0;
  if(tx<=+1.2&&tx>=-1.2&&ty<=+1.2&&ty>=-1.2){if(fire[c][2]<0.0){
    draw4(tx,ty,w[10],h[10],10,eS,eR,eRED,eGREEN,eBLUE,eALPHA,-800000-c);
  }else{
    draw1(tx,ty,w[10],h[10],10,eS,eR,eRED,eGREEN,eBLUE,eALPHA,-800000-c);}}
  else{fire[c][0]=-999.0;fire[c][2]=0.0;fire[c][3]=0.0;}}c+=1;}c=0;
  
  
  // LALALA HERE COMES AN ENEMY, DESTROY IT WITH FIRE!!!!1
while(c<ne_fairy){
if(fairy_f[c][5]==-1.0){
if(fairy_f[c][0]>screen_layer[6][0]+800&&fairy_f[c][0]<screen_layer[6][0]+900
 &&fairy_f[c][1]>screen_layer[6][1]-100&&fairy_f[c][1]<screen_layer[6][1]+580
 &&fairy_i[c][3]==0){fairy_i[c][3]=1;}}else{
if(fairy_f[c][0]>screen_layer[6][0]-100&&fairy_f[c][0]<screen_layer[6][0]
 &&fairy_f[c][1]>screen_layer[6][1]-100&&fairy_f[c][1]<screen_layer[6][1]+580
 &&fairy_i[c][3]==0){fairy_i[c][3]=1;}}
if(fairy_i[c][3]==1){
 if(fairy_i[c][0]>=1){
fairy_f[c][4]+=play_time;
fairy_f[c][2]=(fairy_f[c][0]+scrX)+((fairy_speed*fairy_f[c][4])*fairy_f[c][5])-200;
fairy_f[c][3]=(fairy_f[c][1]+scrY)+(sin(fairy_f[c][4]*fairy_sine_speed)*fairy_sine_height);
if(fairy_f[c][2]<screen_layer[6][0]-100||fairy_f[c][2]>screen_layer[6][0]+900
 ||fairy_f[c][3]<screen_layer[6][1]-100||fairy_f[c][3]>screen_layer[6][1]+580){fairy_i[c][3]=0;}}
while(e<nos){//:::::::::: CHECK IF PLAYER BULLETS HIT.
 if(fire[e][0]!=-999.0){
   if(fire[e][0]>=fairy_f[c][2]-(fairy_width/2.0)&&fire[e][0]<=fairy_f[c][2]+(fairy_width/2.0)
    &&fire[e][1]>=fairy_f[c][3]-(fairy_height/2.0)&&fire[e][1]<=fairy_f[c][3]+(fairy_height/2.0))
   {fairy_i[c][0]-=10;fairy_i[c][2]=SDL_GetTicks();}}
e+=1;}e=0;
if(fairy_i[c][0]>=1){
     eX=fairy_f[c][2];eY=fairy_f[c][3];eT=fairy_first_frame;
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ur=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y+(player_size_Y/2.0)>=eY&&player_position_Y+(player_size_Y/2.0)<=eY+h2[eT]){
      ul=1;}
     if(player_position_X+(player_size_X/2.0)>=eX&&player_position_X+(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      lr=1;}
     if(player_position_X-(player_size_X/2.0)>=eX&&player_position_X-(player_size_X/2.0)<=eX+w2[eT]
      &&player_position_Y-(player_size_Y/2.0)>=eY&&player_position_Y-(player_size_Y/2.0)<=eY+h2[eT]){
      ll=1;}
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tur=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY+h2[eT]<=player_position_Y+(player_size_Y/2.0)&&eY+h2[eT]>=player_position_Y-(player_size_Y/2.0)){
      tul=1;}
     if(eX+w2[eT]<=player_position_X+(player_size_X/2.0)&&eX+w2[eT]>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tlr=1;}
     if(eX<=player_position_X+(player_size_X/2.0)&&eX>=player_position_X-(player_size_X/2.0)
      &&eY<=player_position_Y+(player_size_Y/2.0)&&eY>=player_position_Y-(player_size_Y/2.0)){
      tll=1;}
if(ur==1||ul==1||lr==1||ll==1||tur==1||tul==1||tlr==1||tll==1)
{if(player_death==0){player_death=1;player_death_ani=SDL_GetTicks();}}ur=0;ul=0;lr=0;ll=0;tur=0;tul=0;tlr=0;tll=0;
   eX=((fairy_f[c][2]-scrX)*pixel_to_gl_X)-1.0;
   eY=((fairy_f[c][3]-scrY)*pixel_to_gl_Y)-1.0;
   get_ani_frame(fairy_i[c][2],fairy_number_frames,fairy_alenght,eT);
   if(fairy_f[c][5]==-1.0){
   draw1(eX,eY,fairy_width,fairy_height,20,1.0,0.0,1.0,1.0,1.0,1.0,-2);}else{
   draw4(eX,eY,fairy_width,fairy_height,20,1.0,0.0,1.0,1.0,1.0,1.0,-2);}
}else{txi=SDL_GetTicks()-fairy_i[c][2];if(txi<=2000){
  get_ani_frame(fairy_i[c][2],8,2.0,eT);eT+=12;
  eX=((fairy_f[c][2]-scrX)*pixel_to_gl_X)-1.0;
  eY=((fairy_f[c][3]-scrY)*pixel_to_gl_Y)-1.0;
  draw1(eX,eY,fairy_width,fairy_height,eT,1.0,0.0,1.0,1.0,1.0,1.0,-2);}}}
c+=1;}c=0;

    
// DRAW PLAYER
eX=((player_position_X-scrX)*pixel_to_gl_X)-1.0;
eY=((player_position_Y-scrY)*pixel_to_gl_Y)-1.0;
if(player_death==1){
   txi=SDL_GetTicks()-player_death_ani;if(txi<=2000){
   get_ani_frame(player_death_ani,8,2.0,eT);eT+=12;}else{eT=-1;player_death=0;}
   if(eT!=-1){draw1(eX,eY,32,32,eT,1.0,0.0,1.0,1.0,1.0,1.0,-2);}
 }else{
  if(aim==0&&pdi==1){draw1(eX,eY,player_size_X,player_size_Y,player_tex+2,1.0,0.0,1.0,1.0,1.0,1.0,-2);}
  if(aim==1&&pdi==1){draw1(eX,eY,player_size_X,player_size_Y,player_tex+0,1.0,0.0,1.0,1.0,1.0,1.0,-2);}
  if(aim==2&&pdi==1){draw1(eX,eY,player_size_X,player_size_Y,player_tex+1,1.0,0.0,1.0,1.0,1.0,1.0,-2);}
  if(aim==0&&pdi==0){draw4(eX,eY,player_size_X,player_size_Y,player_tex+2,1.0,0.0,1.0,1.0,1.0,1.0,-2);}
  if(aim==1&&pdi==0){draw4(eX,eY,player_size_X,player_size_Y,player_tex+0,1.0,0.0,1.0,1.0,1.0,1.0,-2);}
  if(aim==2&&pdi==0){draw4(eX,eY,player_size_X,player_size_Y,player_tex+1,1.0,0.0,1.0,1.0,1.0,1.0,-2);}}

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: DRAW TILE MAP (NEAREST LAYER).
eS=1.0;eR=0.0;eRED=1.0;eGREEN=1.0;eBLUE=1.0;eALPHA=1.0;d=7;
  while(d<10){
   if(eds[d]-51>-1){
   while(c<sectord[eds[d]-51][d][0]&&sectord[eds[d]-51][d][0]>0){
     eX=(tile[(sectord[eds[d]-51][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]-51][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]-51][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
   if(eds[d]-50>-1){
   while(c<sectord[eds[d]-50][d][0]&&sectord[eds[d]-50][d][0]>0){
     eX=(tile[(sectord[eds[d]-50][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]-50][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]-50][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
   if(eds[d]-49>-1){
   while(c<sectord[eds[d]-49][d][0]&&sectord[eds[d]-49][d][0]>0){
     eX=(tile[(sectord[eds[d]-49][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]-49][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]-49][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
   if(eds[d]-1>-1){
   while(c<sectord[eds[d]-1][d][0]&&sectord[eds[d]-1][d][0]>0){
     eX=(tile[(sectord[eds[d]-1][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]-1][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]-1][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
   while(c<sectord[eds[d]][d][0]&&sectord[eds[d]][d][0]>0){
     eX=(tile[(sectord[eds[d]][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;
   if(eds[d]+1<2500){
   while(c<sectord[eds[d]+1][d][0]&&sectord[eds[d]+1][d][0]>0){
     eX=(tile[(sectord[eds[d]+1][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]+1][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]+1][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
   if(eds[d]+49<2500){
   while(c<sectord[eds[d]+49][d][0]&&sectord[eds[d]+49][d][0]>0){
     eX=(tile[(sectord[eds[d]+49][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]+49][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]+49][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
   if(eds[d]+50<2500){
   while(c<sectord[eds[d]+50][d][0]&&sectord[eds[d]+50][d][0]>0){
     eX=(tile[(sectord[eds[d]+50][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]+50][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]+50][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
   if(eds[d]+51<2500){
   while(c<sectord[eds[d]+51][d][0]&&sectord[eds[d]+51][d][0]>0){
     eX=(tile[(sectord[eds[d]+51][d][1]+(c*3))+0]-screen_layer[d][0])*pixel_to_gl_X;
     eY=(tile[(sectord[eds[d]+51][d][1]+(c*3))+1]-screen_layer[d][1])*pixel_to_gl_Y;
     eT=tile[(sectord[eds[d]+51][d][1]+(c*3))+2];
     draw2(eX,eY,w[eT],h[eT],eT,eS,eR,eRED,eGREEN,eBLUE,eALPHA,eDEPTH-e-(d*10000));
   c+=1;e+=1;}c=0;}
  d+=1;}d=0;e=0;

  /*
  draw3(-0.5+(0.02*0.0),0.0,8.0,12.0,'a',1.0,1.0,1.0,1.0,-2);
  draw3(-0.5+(0.02*1.0),0.0,8.0,12.0,'b',1.0,1.0,1.0,1.0,-2);
  draw3(-0.5+(0.02*2.0),0.0,8.0,12.0,'c',1.0,1.0,1.0,1.0,-2);
  draw3(-0.5+(0.02*3.0),0.0,8.0,12.0,'d',1.0,1.0,1.0,1.0,-2);
  draw3(-0.5+(0.02*4.0),0.0,8.0,12.0,'e',1.0,1.0,1.0,1.0,-2);
  draw3(-0.5+(0.02*5.0),0.0,8.0,12.0,'f',1.0,1.0,1.0,1.0,-2);
  draw3(-0.5+(0.02*6.0),0.0,8.0,12.0,'g',1.0,1.0,1.0,1.0,-2);
  draw3(-0.5+(0.02*7.0),0.0,8.0,12.0,'h',1.0,1.0,1.0,1.0,-2);
  draw3(-0.5+(0.02*8.0),0.0,8.0,12.0,'i',1.0,1.0,1.0,1.0,-2);
  draw3(-0.5+(0.02*9.0),0.0,8.0,12.0,'j',1.0,1.0,1.0,1.0,-2);
  draw3(-0.5+(0.02*10.0),0.0,8.0,12.0,'k',1.0,1.0,1.0,1.0,-2);
  draw3(-0.5+(0.02*11.0),0.0,8.0,12.0,'l',1.0,1.0,1.0,1.0,-2);
  draw3(-0.5+(0.02*12.0),0.0,12.0,12.0,'m',1.0,1.0,0.0,1.0,-2);
  draw3(-0.5+(0.02*13.0)+0.01,0.0,10.0,12.0,'n',1.0,1.0,0.0,1.0,-2);
  draw3(-0.5+(0.02*14.0)+0.015,0.0,8.0,12.0,'o',1.0,1.0,0.0,1.0,-2);
  draw3(-0.5+(0.02*15.0)+0.015,0.0,8.0,12.0,'p',1.0,1.0,0.0,1.0,-2);
  draw3(-0.5+(0.02*16.0)+0.015,0.0,8.0,12.0,'q',1.0,1.0,0.0,1.0,-2);
  draw3(-0.5+(0.02*17.0)+0.015,0.0,8.0,12.0,'r',0.0,0.0,1.0,1.0,-2);
  draw3(-0.5+(0.02*18.0)+0.015,0.0,8.0,12.0,'s',0.0,1.0,0.0,1.0,-2);
  draw3(-0.5+(0.02*19.0)+0.015,0.0,8.0,12.0,'t',1.0,0.0,0.0,1.0,-2);
  draw3(-0.5+(0.02*20.0)+0.015,0.0,8.0,12.0,'u',1.0,1.0,1.0,0.4,-2);
  draw3(-0.5+(0.02*21.0)+0.015,0.0,10.0,12.0,'v',1.0,1.0,0.0,1.0,-2);
  draw3(-0.5+(0.02*22.0)+0.02,0.0,12.0,12.0,'w',1.0,1.0,0.0,1.0,-2);
  draw3(-0.5+(0.02*23.0)+0.03,0.0,10.0,12.0,'x',1.0,1.0,0.0,1.0,-2);
  draw3(-0.5+(0.02*24.0)+0.035,0.0,8.0,12.0,'y',1.0,1.0,0.0,1.0,-2);
  draw3(-0.5+(0.02*25.0)+0.035,0.0,8.0,12.0,'z',1.0,1.0,0.0,1.0,-2);*/
  
  if(menac==1){
    if(sub_menu==0){
      if(pos==1){messp=mess1;}
      if(pos==2){messp=mess4;}
      if(pos==3){messp=mess5;}}
    if(sub_menu==1){
      if(pos==1){messp=mess11;}
      if(pos==2){messp=mess3;}}
    if(sub_menu==10){
      messp=mess8;}
    if(sub_menu==11){
      messp=mess7;}
    if(sub_menu==2){
      messp=mess10;}
    if(sub_menu==3){
      messp=mess9;}
  while(messp[c]!='\0'){
  messt=messp[c];
  if(messt=='A'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='B'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='C'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='D'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='E'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='F'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='G'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='H'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='I'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='J'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='K'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='L'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='M'){endv=0.03;tx=12.0;ty=12.0;}
  if(messt=='N'){endv=0.025;tx=10.0;ty=12.0;}
  if(messt=='O'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='P'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='Q'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='R'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='S'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='T'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='U'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='V'){endv=0.025;tx=10.0;ty=12.0;}
  if(messt=='W'){endv=0.03;tx=12.0;ty=12.0;}
  if(messt=='X'){endv=0.025;tx=10.0;ty=12.0;}
  if(messt=='Y'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='Z'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt==' '){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='0'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='1'){endv=0.015;tx=6.0;ty=12.0;}
  if(messt=='2'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='3'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='4'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='5'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='6'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='7'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='8'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='9'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='!'){endv=0.015;tx=6.0;ty=12.0;}
  if(messt=='?'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='.'){endv=0.015;tx=6.0;ty=12.0;}
  if(messt==','){endv=0.015;tx=6.0;ty=12.0;}
  if(messt=='-'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='+'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='='){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='/'){endv=0.02;tx=8.0;ty=12.0;}
  if(messt=='*'){endv=0.02;tx=8.0;ty=12.0;}
  draw3(startx+endt,starty,tx,ty,messt,eRED,eGREEN,eBLUE,eALPHA,-999999);
  endt+=endv;
  
  c+=1;}c=0;endt=0.0;
    
  }

//EGL_SwapBuffers();
SDL_GL_SwapBuffers();
glClear(GL_COLOR_BUFFER_BIT);


 
 
 

    if(end_level==1){free_textures(1);level=2;end_level=0;}
 }//****************************************************************** END OF LEVEL 1
 
 
 if(level==2){
 glClear(GL_COLOR_BUFFER_BIT);
 //EGL_SwapBuffers();
 SDL_GL_SwapBuffers();
 }
 
 
 
    Frames++;
    {
	GLint t = SDL_GetTicks();
	if (t - T0 >= 5000) {
	    GLfloat seconds = (t - T0) / 1000.0;
	    GLfloat fps = Frames / seconds;
	    printf("%d frames in %g seconds = %g FPS\n", Frames, seconds, fps);
	    T0 = t;
	    Frames = 0;
	}
    }
currentTime=SDL_GetTicks();
if(currentTime-oldTime<framerate)
{SDL_Delay(framerate-(currentTime-oldTime));}
oldTime=SDL_GetTicks();}
  
myfile.open ("data.txt");
myfile<<  player_speed  <<endl;
myfile<<  fire_speed  <<endl;
myfile<<  dfau  <<endl;
myfile<<  dfas  <<endl;
myfile.close();
 free_textures(level);
 glDisableClientState(GL_VERTEX_ARRAY);
 glDisableClientState(GL_TEXTURE_COORD_ARRAY);
 glDisableClientState(GL_COLOR_ARRAY);
SDL_Quit();
//EGL_Destroy();
return 0;
}
