#ifdef __cplusplus
    #include <cstdlib>
#else
    #include <stdlib.h>
#endif
#ifdef __APPLE__
#include <SDL/SDL.h>
#else
#include <SDL.h>
#endif
#include "GL/gl.h"
#include "math.h"
#include "iostream"
#include "fstream"
#include "lodepng.cpp"
//#include "eglport.c"

// Size of a pixel on Pandoras screen ("2"/800 = 0.0025 = X value) ("2" = openGL -1.0 to 1.0 screen space range)
float pixel_to_gl_X = 0.0025, pixel_to_gl_Y = 0.004166667;
using namespace std;
// NUMBER OF TEXTURES FOR LEVEL
const int ntx=10;
// RESERVE RAM SPACE FOR TEXTURES
 GLuint texture[ntx+1];
 const char* filename[ntx+1];
 unsigned error;
 unsigned char* image[ntx+1];
 unsigned int w[ntx+1],h[ntx+1];int w2[ntx+1],h2[ntx+1],node=ntx;
 int tex_state=0;

void rotate(float xp,float yp,float& ux,float& uy,float degrees){float bt,lx,ly,rx,ry,nnx,a;
if(uy<=yp&&ux>=xp){a=atan((yp-uy)/((ux-xp)))*57.295779579;lx=ux-xp;ly=yp-uy;}if(uy<=yp&&xp>ux)
{a=90.0+(90.0-acos((xp-ux)/(sqrt(((yp-uy)*(yp-uy))+((xp-ux)*(xp-ux)))))*57.295779579);lx=xp-ux;ly=yp-uy;}
if(yp<uy&&xp>ux){a=270.0-(90.0-(atan((uy-yp)/((xp-ux)))*57.295779579));lx=xp-ux;ly=uy-yp;}if(yp<uy&&ux>=xp)
{a=360.0-(acos((ux-xp)/(sqrt(((uy-yp)*(uy-yp))+((ux-xp)*(ux-xp)))))*57.295779579);lx=ux-xp;ly=uy-yp;}
a=((360.0-a)+degrees)+45.0;rx=cos(a*0.017453292)+sin(a*0.017453292);ry=-sin(a*0.017453292)+cos(a*0.017453292);
nnx=sqrt((rx*rx)+(ry*ry));bt=sqrt((lx*lx)+(ly*ly));rx/=nnx;ux=xp+(rx*bt);ry/=nnx;uy=yp-(ry*bt);}

void draw1(float posX, float posY, int width, int height, int texs, float scale, float rotation,
 float r, float g, float b, float a, float layer){float vd[18],td[12],cd[24],v1x,v1y,v2x,v2y,v3x,v3y,v4x,v4y;
  v1x=-width/2.0;v1y=-height/2.0;
  v2x= width/2.0;v2y=-height/2.0;
  v3x=-width/2.0;v3y= height/2.0;
  v4x= width/2.0;v4y= height/2.0;
  if(scale!=1.0){
  v1x*=scale;v1y*=scale;
  v2x*=scale;v2y*=scale;
  v3x*=scale;v3y*=scale;
  v4x*=scale;v4y*=scale;}
  if(rotation!=0.0){
  rotate(0.0,0.0,v1x,v1y,rotation);
  rotate(0.0,0.0,v2x,v2y,rotation);
  rotate(0.0,0.0,v3x,v3y,rotation);
  rotate(0.0,0.0,v4x,v4y,rotation);}
  v1x*=pixel_to_gl_X;v1y*=pixel_to_gl_Y;
  v2x*=pixel_to_gl_X;v2y*=pixel_to_gl_Y;
  v3x*=pixel_to_gl_X;v3y*=pixel_to_gl_Y;
  v4x*=pixel_to_gl_X;v4y*=pixel_to_gl_Y;
   vd[0]=posX+v1x;vd[1]=posY+v1y;vd[2]=layer;
   vd[3]=posX+v2x;vd[4]=posY+v2y;vd[5]=layer;
   vd[6]=posX+v3x;vd[7]=posY+v3y;vd[8]=layer;
   vd[9]= posX+v4x;vd[10]=posY+v4y;vd[11]=layer;
   vd[12]=posX+v3x;vd[13]=posY+v3y;vd[14]=layer;
   vd[15]=posX+v2x;vd[16]=posY+v2y;vd[17]=layer;
   td[0]=0.0; td[1]=1.0;
   td[2]=1.0; td[3]=1.0;
   td[4]=0.0; td[5]=0.0;
   td[6]=1.0; td[7]=0.0;
   td[8]=0.0; td[9]=0.0;
   td[10]=1.0;td[11]=1.0;
   cd[0]=r; cd[1]=g; cd[2]=b; cd[3]=a;
   cd[4]=r; cd[5]=g; cd[6]=b; cd[7]=a;
   cd[8]=r; cd[9]=g; cd[10]=b;cd[11]=a;
   cd[12]=r;cd[13]=g;cd[14]=b;cd[15]=a;
   cd[16]=r;cd[17]=g;cd[18]=b;cd[19]=a;
   cd[20]=r;cd[21]=g;cd[22]=b;cd[23]=a;
  glColorPointer(4,GL_FLOAT,0,cd);
  glTexCoordPointer(2,GL_FLOAT,0,td);
  glVertexPointer(3,GL_FLOAT,0,vd);
  glBindTexture(GL_TEXTURE_2D, texture[texs]);
  glDrawArrays(GL_TRIANGLES,0,6);}

void draw2(float posX, float posY, int width, int height, int texs, float scale, float rotation,
 float r, float g, float b, float a, float layer){float vd[18],td[12],cd[24],v1x,v1y,v2x,v2y,v3x,v3y,v4x,v4y;
  v1x=width*pixel_to_gl_X;v1y=height*pixel_to_gl_Y;
   vd[0]=posX;     vd[1]=posY;     vd[2]=layer;
   vd[3]=posX+v1x; vd[4]=posY;     vd[5]=layer;
   vd[6]=posX;     vd[7]=posY+v1y; vd[8]=layer;
   vd[9]= posX+v1x;vd[10]=posY+v1y;vd[11]=layer;
   vd[12]=posX;    vd[13]=posY+v1y;vd[14]=layer;
   vd[15]=posX+v1x;vd[16]=posY;    vd[17]=layer;
   td[0]=0.0; td[1]=1.0;
   td[2]=1.0; td[3]=1.0;
   td[4]=0.0; td[5]=0.0;
   td[6]=1.0; td[7]=0.0;
   td[8]=0.0; td[9]=0.0;
   td[10]=1.0;td[11]=1.0;
   cd[0]=r; cd[1]=g; cd[2]=b; cd[3]=a;
   cd[4]=r; cd[5]=g; cd[6]=b; cd[7]=a;
   cd[8]=r; cd[9]=g; cd[10]=b;cd[11]=a;
   cd[12]=r;cd[13]=g;cd[14]=b;cd[15]=a;
   cd[16]=r;cd[17]=g;cd[18]=b;cd[19]=a;
   cd[20]=r;cd[21]=g;cd[22]=b;cd[23]=a;
  glColorPointer(4,GL_FLOAT,0,cd);
  glTexCoordPointer(2,GL_FLOAT,0,td);
  glVertexPointer(3,GL_FLOAT,0,vd);
  glBindTexture(GL_TEXTURE_2D, texture[texs]);
  glDrawArrays(GL_TRIANGLES,0,6);}

void load_textures(){//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  filename[0]="mechaf.png";
  filename[1]="mechau.png";
  filename[2]="mechad.png";
  filename[3]="cannonl.png";
  filename[4]="cannonr.png";
  filename[5]="cannonu.png";
  filename[6]="cannond.png";
  filename[7]="test2.png";
  filename[8]="test5.png";
  filename[9]="machine1.png";
  filename[10]="node.png";
   for(int i=0;i<ntx+1;i++){
   error = lodepng_decode32_file(&image[i], &w[i], &h[i], filename[i]);
   w2[i]=w[i];h2[i]=h[i];
   glGenTextures(1,&texture[i]);
   glBindTexture(GL_TEXTURE_2D, texture[i]);
   glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,w[i],h[i],0,GL_RGBA,GL_UNSIGNED_BYTE,image[i]);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);}//********** END LEVEL NTX.
 tex_state=1;}

void free_textures(){//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    for(int i=0;i<ntx+1;i++){
    free(image[i]);
    glDeleteTextures(1,&texture[i]);}
}//****************************************************************************************************




int main ( int argc, char** argv )
{
    // initialize SDL video
    if ( SDL_Init( SDL_INIT_VIDEO ) < 0 )
    {
        printf( "Unable to init SDL: %s\n", SDL_GetError() );
        return 1;
    }

    // make sure SDL cleans up before exit
    atexit(SDL_Quit);

 int screen_width = 800, screen_height = 480;
  SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER);
  SDL_Surface* sl1=SDL_SetVideoMode(screen_width,screen_height,32,SDL_HWSURFACE|SDL_OPENGL|SDL_DOUBLEBUF);
  SDL_Event gameover,mouse;Uint8* key;int quit=0,c=0,d=0,e=0,f=0,g=0;
  unsigned int oldTime=0,currentTime=0,framerate=25;//1000/10=100fps
 glClearColor(0.0,0.0,0.0,0.0);
 glShadeModel(GL_SMOOTH);
 glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
 glEnable(GL_BLEND);
 glEnable(GL_TEXTURE_2D);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
 glOrtho(-1.0,1.0,-1.0,1.0,1.0,1600000.0);
 glEnableClientState(GL_VERTEX_ARRAY);
 glEnableClientState(GL_TEXTURE_COORD_ARRAY);
 glEnableClientState(GL_COLOR_ARRAY);

 fstream myfile;
 float vd2[18],td2[12],cd2[24];
  int player=1,end_level=0,level=1,noeT1=1;
  float play_time=0.0,death_time=0,f1=0.7,fmx=0.1,fmy=0.0,anix,anix2;
  int fire_size_X=32,fire_size_Y=32,fire_damage=1;
  float fire_t1_X=0.1,fire_t1_Y=0.0;
float player_pos_X=-0.5,player_pos_Y=0.0,player_speed=1.0;
int player_size_X=256,player_size_Y=256,player_tex=0;
float timeval=1.0,ms;int cto,ctu,ptu;


int ne1=5;// NUMBER OF ENEMIES OF TYPE
float enemy1[ne1][7];
while(c<ne1){
enemy1[c][0]=3.0+c*0.5;// X STARTING POSITION
enemy1[c][1]=0.0;// Y STARTING POSITION
enemy1[c][2]=0.0;// SINE TIME VALUE
enemy1[c][3]=1.0;// HITPOINTS
enemy1[c][4]=0.0;// DEATH ANIMATION STARTING TIME
enemy1[c][5]=0.0;// DYNAMIC X POSITION
enemy1[c][6]=0.0;// DYNAMIC Y POSITION
c+=1;}c=0;
float enemy1_sine_height=32.0 * pixel_to_gl_Y;// TOTAL DIFFERENCE IN HEIGHT (in pixels)
float enemy1_speed=0.5;// SPEED OF MOVING FOWARDS (in GL per second, one screen = 2.0 GL)
float enemy1_sine_speed=5.5;// SPEED OF MOVING UP/DOWN
float enemy1_depth=-5.0;// STARTING DEPTH VALUE FOR ENEMY TYPE
int enemy1_width=256;// WIDTH OF ENEMY PHYSICS
int enemy1_height=256;// HEIGHT OF ENEMY PHYSICS
int enemy1_first_frame=0;// FIRST FRAME FOR ANIMATION (in texture number)
int enemy1_first_death=4;// FIRST FRAME FOR DEATH ANIMATION
int enemy1_number_frames=2;// NUMBER OF FRAMES FOR ANIMATION
int enemy1_number_death=1;// NUMBER OF FRAMES FOR DEATH ANIMATION
float enemy1_alenght=2.0;// ANIMATION LENGHT (1.0 = 1 second)
float enemy1_dlenght=1.0;// DEATH ANIMATION LENGHT

float eX,eY,eS=1.0,eR=0.0,eRED=1.0,eGREEN=1.0,eBLUE=1.0,eALPHA=1.0,eDEPTH=-1.0,alph=1.0,colt=1.0;int eA=0;
int filla=0,fillap=0,smy1=0,smy1p=0,smy2=0,smy2p=0,smx1=0,smx1p=0,smx2=0,smx2p=0,scrX=0,scrY=0,lshift=0,ctrl=0;
int lH=0,ch0=0,ch0p=0,ch1=0,ch1p=0,ch2=0,ch2p=0,ch3=0,ch3p=0,ch4=0,ch4p=0,ch5=0,ch5p=0,ch6=0,ch6p=0,ch7=0,ch7p=0;
int ch8=0,ch8p=0,ch9=0,ch9p=0,cog1=0,cogp1=0,cog2=0,cogp2=0,cog3=0,cogp3=0,cog4=0,cogp4=0,mta=0,mtap=0,mtb=0,mtbp=0;
int grid=32,selt[10],bl=3,moldx=0,moldy=0,moldt=0,screen_X,screen_Y,sH=0,saveh=0,savehp=0,loadh=0,loadhp=0;
int mouses,mousex,mousey,mvx,mvy,mvs=0,mvd=0,chooset=-1,ctn=0,ctnp=0,ctm=0,ctmp=0,cog0=0,cogp0=0,env=0,envp=0;
int selnm=0,selnmp=0,selnp=0,selnpp=0,mnode=0,nmy1=0,nmy1p=0,nmy2=0,nmy2p=0,nmx1=0,nmx1p=0,nmx2=0,nmx2p=0;
float noldx[9999],noldy[9999],noldv[9999][3];int sn=0,ed=0,edh=0,choosed=0,ctb=0,ctbp=0,nodx=0,nody=0,cts=0,ctsp=0;
int psi=0,psip=0,selt2=0,ssaveh=0,ssavehp=0,choosed2=-1,ceds[10];
static int tile0[1500000][4],tile1[1500000][4],tile2[1500000][4],tile3[1500000][4],tile4[1500000][4],
tile5[1500000][4],tile6[1500000][4],tile7[1500000][4],tile8[1500000][4],tile9[1500000][4],tiles[7500000],
sectord[2500][10][2];float vd[18],cd[24];
int mt = 1500000;
while(c<1500000){
tile0[c][0]=-999;// X POSITION
tile0[c][1]=-999;// Y POSITION
tile0[c][2]=-1;// TEXTURE
tile0[c][3]=-1;// SECTOR
tile1[c][0]=-999;
tile1[c][1]=-999;
tile1[c][2]=-1;
tile1[c][3]=-1;
tile2[c][0]=-999;
tile2[c][1]=-999;
tile2[c][2]=-1;
tile2[c][3]=-1;
tile3[c][0]=-999;
tile3[c][1]=-999;
tile3[c][2]=-1;
tile3[c][3]=-1;
tile4[c][0]=-999;
tile4[c][1]=-999;
tile4[c][2]=-1;
tile4[c][3]=-1;
tile5[c][0]=-999;
tile5[c][1]=-999;
tile5[c][2]=-1;
tile5[c][3]=-1;
tile6[c][0]=-999;
tile6[c][1]=-999;
tile6[c][2]=-1;
tile6[c][3]=-1;
tile7[c][0]=-999;
tile7[c][1]=-999;
tile7[c][2]=-1;
tile7[c][3]=-1;
tile8[c][0]=-999;
tile8[c][1]=-999;
tile8[c][2]=-1;
tile8[c][3]=-1;
tile9[c][0]=-999;
tile9[c][1]=-999;
tile9[c][2]=-1;
tile9[c][3]=-1;
c+=1;}c=0;
//while(c<5){selt[c]=0;c+=1;}c=0;// AVAILABLE TILE ON LAYER X
while(c<9999){noldx[c]=0;noldy[c]=0;noldv[c][0]=240;noldv[c][1]=240;noldv[c][2]=1.0;c+=1;}c=0;
while(c<2500){while(d<10){sectord[c][d][0]=0;sectord[c][d][1]=0;d+=1;}d=0;c+=1;}c=0;
int eds[10],ct[10];
while(c<10){eds[c]=0;ceds[c]=0;ct[c]=-1;selt[c]=0;c+=1;}c=0;

//static int ntile[10][500000][3];
/*  myfile.open ("map3st.txt");
  while(c<2500){while(d<10){while(e<500){
  myfile<<  ntile[c][d][e][0]  <<endl;
  myfile<<  ntile[c][d][e][1]  <<endl;
  myfile<<  ntile[c][d][e][2]  <<endl;
  e+=1;}e=0;d+=1;}d=0;c+=1;}c=0;
  myfile.close();*/

float parralax_speed[10];// SPEED OF SCROLLING LAYERS.
parralax_speed[0]=0.0;// FURTHEST IN LAYER
parralax_speed[1]=0.2;
parralax_speed[2]=0.35;
parralax_speed[3]=0.5;
parralax_speed[4]=0.65;
parralax_speed[5]=0.8;
parralax_speed[6]=1.0;// MAIN LAYER
parralax_speed[7]=1.0;
parralax_speed[8]=1.4;
parralax_speed[9]=1.8;// NEAREST LAYER

float screen_layer[10][3];
while(c<10){
  screen_layer[c][0]=0.0;// X POSITION OF LAYER
  screen_layer[c][1]=0.0;// Y POSITION OF LAYER
  screen_layer[c][2]=parralax_speed[c];// SPEED OF SCROLL (in relation to layer 6 (standard layer))
c+=1;}c=0;


load_textures();

  //  GAME LOOP STARTS HERE **************************************
while(quit==0){
while(SDL_PollEvent(&mouse)){mouses=SDL_GetMouseState(&mousex,&mousey);
  //if(mouses & SDL_BUTTON(SDL_BUTTON_LEFT)){mvs=1;}else{mvs=0;}

}
while(SDL_PollEvent(&gameover))
{if(gameover.type==SDL_QUIT){quit=1;}}

 key=SDL_GetKeyState(NULL);  //       CONTROLS
 if(key[SDLK_ESCAPE]){quit=1;}

 if(key[SDLK_s]){sH=1;}else{sH=0;}
 if(key[SDLK_LSHIFT]){lshift=1;}else{lshift=0;}
 if(key[SDLK_LCTRL]){ctrl=1;}else{ctrl=0;}
 if(key[SDLK_k]){mnode=1;}else{mnode=0;}
 if(key[SDLK_F1]){saveh=1;}else{savehp=0;}
 if(key[SDLK_F3]){ssaveh=1;}else{ssavehp=0;}
 if(key[SDLK_F5]){loadh=1;}else{loadhp=0;}
 if(key[SDLK_1]){if(bl!=1){ch1=1;}}else{ch1p=0;}
 if(key[SDLK_2]){if(bl!=2){ch2=1;}}else{ch2p=0;}
 if(key[SDLK_3]){if(bl!=3){ch3=1;}}else{ch3p=0;}
 if(key[SDLK_4]){if(bl!=4){ch4=1;}}else{ch4p=0;}
 if(key[SDLK_5]){if(bl!=5){ch5=1;}}else{ch5p=0;}
 if(key[SDLK_6]){if(bl!=6){ch6=1;}}else{ch6p=0;}
 if(key[SDLK_7]){if(bl!=7){ch7=1;}}else{ch7p=0;}
 if(key[SDLK_8]){if(bl!=8){ch8=1;}}else{ch8p=0;}
 if(key[SDLK_9]){if(bl!=9){ch9=1;}}else{ch9p=0;}
 if(key[SDLK_0]){if(bl!=0){ch0=1;}}else{ch0p=0;}
 if(key[SDLK_UP]){
   if(ctrl==0&&lshift==0&&sH==0&&mnode==1){nmy1=1;}
   if(ctrl==0&&lshift==1&&sH==0&&mnode==1){noldy[sn]+=grid;}
   if(ctrl==1&&lshift==0&&sH==0&&mnode==1){noldy[sn]+=grid*10;}
   if(ctrl==0&&lshift==0&&sH==1&&mnode==0){scrY+=grid;}
   if(ctrl==0&&lshift==0&&sH==0&&mnode==0){smy1=1;}
   if(ctrl==0&&lshift==1&&sH==0&&mnode==0){moldy+=grid;}
   if(ctrl==1&&lshift==0&&sH==0&&mnode==0){moldy+=grid*10;}}else{smy1p=0;nmy1p=0;}
 if(key[SDLK_DOWN]){
   if(ctrl==0&&lshift==0&&sH==0&&mnode==1){nmy2=1;}
   if(ctrl==0&&lshift==1&&sH==0&&mnode==1){noldy[sn]-=grid;}
   if(ctrl==1&&lshift==0&&sH==0&&mnode==1){noldy[sn]-=grid*10;}
   if(ctrl==0&&lshift==0&&sH==1&&mnode==0){scrY-=grid;}
   if(ctrl==0&&lshift==0&&sH==0&&mnode==0){smy2=1;}
   if(ctrl==0&&lshift==1&&sH==0&&mnode==0){moldy-=grid;}
   if(ctrl==1&&lshift==0&&sH==0&&mnode==0){moldy-=grid*10;}}else{smy2p=0;nmy2p=0;}
 if(key[SDLK_LEFT]){
   if(ctrl==0&&lshift==0&&sH==0&&mnode==1){nmx1=1;}
   if(ctrl==0&&lshift==1&&sH==0&&mnode==1){noldx[sn]-=grid;}
   if(ctrl==1&&lshift==0&&sH==0&&mnode==1){noldx[sn]-=grid*10;}
   if(ctrl==0&&lshift==0&&sH==1&&mnode==0){scrX-=grid;if(scrX<0){scrX=0;}}
   if(ctrl==0&&lshift==0&&sH==0&&mnode==0){smx1=1;}
   if(ctrl==0&&lshift==1&&sH==0&&mnode==0){moldx-=grid;}
   if(ctrl==1&&lshift==0&&sH==0&&mnode==0){moldx-=grid*10;}}else{smx1p=0;nmx1p=0;}
 if(key[SDLK_RIGHT]){
   if(ctrl==0&&lshift==0&&sH==0&&mnode==1){nmx2=1;}
   if(ctrl==0&&lshift==1&&sH==0&&mnode==1){noldx[sn]+=grid;}
   if(ctrl==1&&lshift==0&&sH==0&&mnode==1){noldx[sn]+=grid*10;}
   if(ctrl==0&&lshift==0&&sH==1&&mnode==0){scrX+=grid;}
   if(ctrl==0&&lshift==0&&sH==0&&mnode==0){smx2=1;}
   if(ctrl==0&&lshift==1&&sH==0&&mnode==0){moldx+=grid;}
   if(ctrl==1&&lshift==0&&sH==0&&mnode==0){moldx+=grid*10;}}else{smx2p=0;nmx2p=0;}
 if(key[SDLK_SPACE]){filla=1;}else{fillap=0;}
 if(key[SDLK_a]){chooset=-1;}
 if(key[SDLK_b]){ctb=1;}else{ctbp=0;}
 if(key[SDLK_n]){ctn=1;}else{ctnp=0;}
 if(key[SDLK_m]){ctm=1;}else{ctmp=0;}
 if(key[SDLK_v]){cts=1;}else{ctsp=0;}
 if(key[SDLK_f]){mvs=1;}else{mvs=0;}
 if(key[SDLK_d]){mvd=1;}else{mvd=0;}
 if(key[SDLK_z]){mta=1;}else{mtap=0;}
 if(key[SDLK_x]){mtb=1;}else{mtbp=0;}
 if(key[SDLK_h]){selnm=1;}else{selnmp=0;}
 if(key[SDLK_j]){selnp=1;}else{selnpp=0;}
 if(key[SDLK_l]){env=1;}else{envp=0;}
 if(key[SDLK_i]){psi=1;}else{psip=0;}
 if(key[SDLK_p]){chooset=selt2;}
 if(key[SDLK_q]){grid=1;cog0=1;}else{cogp0=0;}
 if(key[SDLK_w]){grid=8;cog1=1;}else{cogp1=0;}
 if(key[SDLK_e]){grid=16;cog2=1;}else{cogp2=0;}
 if(key[SDLK_r]){grid=32;cog3=1;}else{cogp3=0;}
 if(key[SDLK_t]){grid=64;cog4=1;}else{cogp4=0;}// END OF CONTROLS


while(c<10){
  screen_layer[c][0]=(float)scrX*screen_layer[c][2];
  screen_layer[c][1]=(float)scrY*screen_layer[c][2];
c+=1;}c=0;

//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: SELECT NODE.
if(selnm==1&&selnmp==0){sn-=1;if(sn<0){sn=0;}cout<<"Selected NODE "<<sn<<endl;selnmp=1;}selnm=0;
if(selnp==1&&selnpp==0){sn+=1;if(sn>9998){sn=9998;}cout<<"Selected NODE "<<sn<<endl;selnpp=1;}selnp=0;

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: ENTER NODE VALUES.
if(env==1&&envp==0){
  cout<<"Enter value for height... ";cin>>noldv[sn][0];
  cout<<"Enter value for bottom... ";cin>>noldv[sn][1];
  if(noldv[sn][0]<240){noldv[sn][0]=240;}
  if(noldv[sn][1]<240){noldv[sn][1]=240;}
  cout<<"Enter value for speed... ";cin>>noldv[sn][2];
  cout<<"Height value = "<<noldv[sn][0]<<", bottom value = "<<noldv[sn][1]<<endl;
envp=1;}env=0;

//::::::::::::::::::::::::::::::::::::::: PRINT OUT THE GRID SIZE.
if(cog0==1&&cogp0==0){cout<<"GRID = "<<grid<<endl;cogp0=1;}cog0=0;
if(cog1==1&&cogp1==0){cout<<"GRID = "<<grid<<endl;cogp1=1;}cog1=0;
if(cog2==1&&cogp2==0){cout<<"GRID = "<<grid<<endl;cogp2=1;}cog2=0;
if(cog3==1&&cogp3==0){cout<<"GRID = "<<grid<<endl;cogp3=1;}cog3=0;
if(cog4==1&&cogp4==0){cout<<"GRID = "<<grid<<endl;cogp4=1;}cog4=0;

//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: SELECT TILE.
if(ctn==1&&ctnp==0){ct[bl]-=grid;if(ct[bl]<0){ct[bl]=0;}cout<<"Selected TILE "<<ct[bl]<<endl;ctnp=1;}ctn=0;
if(ctm==1&&ctmp==0){ct[bl]+=grid;if(ct[bl]>=mt){ct[bl]=mt-1;}cout<<"Selected TILE "<<ct[bl]<<endl;ctmp=1;}ctm=0;
if(cts==1&&ctsp==0){ct[bl]=-1;cout<<"Dropped selection..."<<endl;ctsp=1;}cts=0;// DROP SELECTION. (also with A)

//:::::: MOVE MOLD ONLY ONE STEP PER BUTTON PRESS.
if(smy1==1&&smy1p==0){moldy+=grid;smy1p=1;}smy1=0;
if(smy2==1&&smy2p==0){moldy-=grid;smy2p=1;}smy2=0;
if(smx1==1&&smx1p==0){moldx-=grid;smx1p=1;}smx1=0;
if(smx2==1&&smx2p==0){moldx+=grid;smx2p=1;}smx2=0;

//:::::::::::::::::::::::: KEEP THE MOLD IN VISIBLE SCREEN AREA.
if(moldx<0){moldx=0;}if(moldx>800-w[moldt]){moldx=800-w[moldt];}
if(moldy<0){moldy=0;}if(moldy>480-h[moldt]){moldy=480-h[moldt];}

//:::::::::: MOVE NODE ONLY ONE STEP PER BUTTON PRESS.
if(noldx[sn]==0&&noldy[sn]==0&&sn>0){noldx[sn]=noldx[sn-1];noldy[sn]=noldy[sn-1];}
if(nmy1==1&&nmy1p==0){noldy[sn]+=grid;nmy1p=1;}nmy1=0;
if(nmy2==1&&nmy2p==0){noldy[sn]-=grid;nmy2p=1;}nmy2=0;
if(nmx1==1&&nmx1p==0){noldx[sn]-=grid;nmx1p=1;}nmx1=0;
if(nmx2==1&&nmx2p==0){noldx[sn]+=grid;nmx2p=1;}nmx2=0;

/*if(psi==1&&psip==0){
  cout<<"********************************************************"<<endl;
  cout<<"Selected NODE values..."<<endl;
  cout<<"   X = "<<noldx[sn]<<endl;
  cout<<"   Y = "<<noldy[sn]<<endl;
  cout<<"   height = "<<noldv[sn][0]<<endl;
  cout<<"   bottom = "<<noldv[sn][1]<<endl;
  cout<<"   speed = "<<noldv[sn][2]<<endl<<endl;
  cout<<"MOLD coordinates"<<endl<<"   X = "<<moldx<<endl<<"   Y = "<<moldy<<endl;
  cout<<endl<<"MOLD hovers in area "<<choosed<<endl<<endl;
  cout<<"Total amount of TILES = "<<selt2<<endl;
  cout<<"SECTOR of choosen TILE = "<<tile[chooset][3]<<endl;
  cout<<"********************************************************"<<endl;
psip=1;}psi=0;*/

// 50x50x1000 = 2500000
//::::::::::::::::::::::::::::::::::::::::::::: GET THE DYNAMIC LOADING ARRAY SLOT VALUE.
float hmm;
while(c<10){
hmm=(float)screen_layer[c][1]/480.0;e=hmm;hmm=(float)screen_layer[c][0]/800.0;d=hmm;eds[c]=e+(d*50)+25;
hmm=(float)(screen_layer[bl][1]+moldy-240)/480.0;e=hmm;
hmm=(float)(screen_layer[bl][0]+moldx-400)/800.0;d=hmm;ceds[c]=e+(d*50)+25;c+=1;}c=0;d=0;e=0;



//::::::::::::::::::::::::::::::::::::::::::::::::::::: CHANGE TEXTURE.
if(mta==1&&mtap==0){moldt-=1;if(moldt<0){moldt=0;}mtap=1;}mta=0;
if(mtb==1&&mtbp==0){moldt+=1;if(moldt>=ntx){moldt=ntx-1;}mtbp=1;}mtb=0;

//::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: SELECT A BACKGROUND LAYER.
if(ch0==1&&ch0p==0){ct[bl]=-1;bl=0;cout<<"Selected Background Layer "<<bl<<endl;ch0p=1;}ch0=0;
if(ch1==1&&ch1p==0){ct[bl]=-1;bl=1;cout<<"Selected Background Layer "<<bl<<endl;ch1p=1;}ch1=0;
if(ch2==1&&ch2p==0){ct[bl]=-1;bl=2;cout<<"Selected Background Layer "<<bl<<endl;ch2p=1;}ch2=0;
if(ch3==1&&ch3p==0){ct[bl]=-1;bl=3;cout<<"Selected Background Layer "<<bl<<endl;ch3p=1;}ch3=0;
if(ch4==1&&ch4p==0){ct[bl]=-1;bl=4;cout<<"Selected Background Layer "<<bl<<endl;ch4p=1;}ch4=0;
if(ch5==1&&ch5p==0){ct[bl]=-1;bl=5;cout<<"Selected Background Layer "<<bl<<endl;ch5p=1;}ch5=0;
if(ch6==1&&ch6p==0){ct[bl]=-1;bl=6;cout<<"Selected Background Layer "<<bl<<endl;ch6p=1;}ch6=0;
if(ch7==1&&ch7p==0){ct[bl]=-1;bl=7;cout<<"Selected Background Layer "<<bl<<endl;ch7p=1;}ch7=0;
if(ch8==1&&ch8p==0){ct[bl]=-1;bl=8;cout<<"Selected Background Layer "<<bl<<endl;ch8p=1;}ch8=0;
if(ch9==1&&ch9p==0){ct[bl]=-1;bl=9;cout<<"Selected Background Layer "<<bl<<endl;ch9p=1;}ch9=0;

//::::::::::::::::::::::::::::::: PUT SELECTED TEXTURE ON SELECTED BACKGROUND LAYER WITH MOLD COORDINATES.
if(filla==1&&fillap==0){
  if(bl==0){
    tile0[selt[bl]][0]=screen_layer[bl][0]+(moldx-400);tile0[selt[bl]][1]=screen_layer[bl][1]+(moldy-240);
    tile0[selt[bl]][2]=moldt;tile0[selt[bl]][3]=ceds[bl];
    selt2+=1;selt[bl]+=1;if(selt2>1499999){selt2-=1;selt[bl]-=1;}}
  if(bl==1){
    tile1[selt[bl]][0]=screen_layer[bl][0]+(moldx-400);tile1[selt[bl]][1]=screen_layer[bl][1]+(moldy-240);
    tile1[selt[bl]][2]=moldt;tile1[selt[bl]][3]=ceds[bl];
    selt2+=1;selt[bl]+=1;if(selt2>1499999){selt2-=1;selt[bl]-=1;}}
  if(bl==2){
    tile2[selt[bl]][0]=screen_layer[bl][0]+(moldx-400);tile2[selt[bl]][1]=screen_layer[bl][1]+(moldy-240);
    tile2[selt[bl]][2]=moldt;tile2[selt[bl]][3]=ceds[bl];
    selt2+=1;selt[bl]+=1;if(selt2>1499999){selt2-=1;selt[bl]-=1;}}
  if(bl==3){
    tile3[selt[bl]][0]=screen_layer[bl][0]+(moldx-400);tile3[selt[bl]][1]=screen_layer[bl][1]+(moldy-240);
    tile3[selt[bl]][2]=moldt;tile3[selt[bl]][3]=ceds[bl];
    selt2+=1;selt[bl]+=1;if(selt2>1499999){selt2-=1;selt[bl]-=1;}}
  if(bl==4){
    tile4[selt[bl]][0]=screen_layer[bl][0]+(moldx-400);tile4[selt[bl]][1]=screen_layer[bl][1]+(moldy-240);
    tile4[selt[bl]][2]=moldt;tile4[selt[bl]][3]=ceds[bl];
    selt2+=1;selt[bl]+=1;if(selt2>1499999){selt2-=1;selt[bl]-=1;}}
  if(bl==5){
    tile5[selt[bl]][0]=screen_layer[bl][0]+(moldx-400);tile5[selt[bl]][1]=screen_layer[bl][1]+(moldy-240);
    tile5[selt[bl]][2]=moldt;tile5[selt[bl]][3]=ceds[bl];
    selt2+=1;selt[bl]+=1;if(selt2>1499999){selt2-=1;selt[bl]-=1;}}
  if(bl==6){
    tile6[selt[bl]][0]=screen_layer[bl][0]+(moldx-400);tile6[selt[bl]][1]=screen_layer[bl][1]+(moldy-240);
    tile6[selt[bl]][2]=moldt;tile6[selt[bl]][3]=ceds[bl];
    selt2+=1;selt[bl]+=1;if(selt2>1499999){selt2-=1;selt[bl]-=1;}}
  if(bl==7){
    tile7[selt[bl]][0]=screen_layer[bl][0]+(moldx-400);tile7[selt[bl]][1]=screen_layer[bl][1]+(moldy-240);
    tile7[selt[bl]][2]=moldt;tile7[selt[bl]][3]=ceds[bl];
    selt2+=1;selt[bl]+=1;if(selt2>1499999){selt2-=1;selt[bl]-=1;}}
  if(bl==8){
    tile8[selt[bl]][0]=screen_layer[bl][0]+(moldx-400);tile8[selt[bl]][1]=screen_layer[bl][1]+(moldy-240);
    tile8[selt[bl]][2]=moldt;tile8[selt[bl]][3]=ceds[bl];
    selt2+=1;selt[bl]+=1;if(selt2>1499999){selt2-=1;selt[bl]-=1;}}
  if(bl==9){
    tile9[selt[bl]][0]=screen_layer[bl][0]+(moldx-400);tile9[selt[bl]][1]=screen_layer[bl][1]+(moldy-240);
    tile9[selt[bl]][2]=moldt;tile9[selt[bl]][3]=ceds[bl];
    selt2+=1;selt[bl]+=1;if(selt2>1499999){selt2-=1;selt[bl]-=1;}}
  while(c<1500000){
    if(tile0[c][3]==ceds[bl]){d+=1;}
    if(tile1[c][3]==ceds[bl]){d+=1;}
    if(tile2[c][3]==ceds[bl]){d+=1;}
    if(tile3[c][3]==ceds[bl]){d+=1;}
    if(tile4[c][3]==ceds[bl]){d+=1;}
    if(tile5[c][3]==ceds[bl]){d+=1;}
    if(tile6[c][3]==ceds[bl]){d+=1;}
    if(tile7[c][3]==ceds[bl]){d+=1;}
    if(tile8[c][3]==ceds[bl]){d+=1;}
    if(tile9[c][3]==ceds[bl]){d+=1;}
  c+=1;}c=0;
  cout<<"Put TILE number "<<d<<" in area "<<ceds[bl]<<endl;
  cout<<"Total amount of tiles = "<<selt2<<endl;
fillap=1;}filla=0;d=0;

//:::::::::::::::::::::::::::::::: SELECT A TILE (WITH MOUSE + F).
mvx=mousex+screen_layer[bl][0]-400;mvy=(480-mousey)+screen_layer[bl][1]-240;
if(mvs==1){
  if(bl==0){while(c<selt[bl]){
  if(mvx>=tile0[c][0]&&mvx<=tile0[c][0]+w2[tile0[c][2]]&&
     mvy>=tile0[c][1]&&mvy<=tile0[c][1]+h2[tile0[c][2]]){
  ct[bl]=c;}c+=1;}c=0;}
  if(bl==1){while(c<selt[bl]){
  if(mvx>=tile1[c][0]&&mvx<=tile1[c][0]+w2[tile1[c][2]]&&
     mvy>=tile1[c][1]&&mvy<=tile1[c][1]+h2[tile1[c][2]]){
  ct[bl]=c;}c+=1;}c=0;}
  if(bl==2){while(c<selt[bl]){
  if(mvx>=tile2[c][0]&&mvx<=tile2[c][0]+w2[tile2[c][2]]&&
     mvy>=tile2[c][1]&&mvy<=tile2[c][1]+h2[tile2[c][2]]){
  ct[bl]=c;}c+=1;}c=0;}
  if(bl==3){while(c<selt[bl]){
  if(mvx>=tile3[c][0]&&mvx<=tile3[c][0]+w2[tile3[c][2]]&&
     mvy>=tile3[c][1]&&mvy<=tile3[c][1]+h2[tile3[c][2]]){
  ct[bl]=c;}c+=1;}c=0;}
  if(bl==4){while(c<selt[bl]){
  if(mvx>=tile4[c][0]&&mvx<=tile4[c][0]+w2[tile4[c][2]]&&
     mvy>=tile4[c][1]&&mvy<=tile4[c][1]+h2[tile4[c][2]]){
  ct[bl]=c;}c+=1;}c=0;}
  if(bl==5){while(c<selt[bl]){
  if(mvx>=tile5[c][0]&&mvx<=tile5[c][0]+w2[tile5[c][2]]&&
     mvy>=tile5[c][1]&&mvy<=tile5[c][1]+h2[tile5[c][2]]){
  ct[bl]=c;}c+=1;}c=0;}
  if(bl==6){while(c<selt[bl]){
  if(mvx>=tile6[c][0]&&mvx<=tile6[c][0]+w2[tile6[c][2]]&&
     mvy>=tile6[c][1]&&mvy<=tile6[c][1]+h2[tile6[c][2]]){
  ct[bl]=c;}c+=1;}c=0;}
  if(bl==7){while(c<selt[bl]){
  if(mvx>=tile7[c][0]&&mvx<=tile7[c][0]+w2[tile7[c][2]]&&
     mvy>=tile7[c][1]&&mvy<=tile7[c][1]+h2[tile7[c][2]]){
  ct[bl]=c;}c+=1;}c=0;}
  if(bl==8){while(c<selt[bl]){
  if(mvx>=tile8[c][0]&&mvx<=tile8[c][0]+w2[tile8[c][2]]&&
     mvy>=tile8[c][1]&&mvy<=tile8[c][1]+h2[tile8[c][2]]){
  ct[bl]=c;}c+=1;}c=0;}
  if(bl==9){while(c<selt[bl]){
  if(mvx>=tile9[c][0]&&mvx<=tile9[c][0]+w2[tile9[c][2]]&&
     mvy>=tile9[c][1]&&mvy<=tile9[c][1]+h2[tile9[c][2]]){
  ct[bl]=c;}c+=1;}c=0;}
  cout<<"Selected TILE "<<chooset<<", in AREA "<<choosed2<<endl;}

//::::::::::::::::::: DELETE A TILE.
if(mvd==1&&chooset!=-1){
  if(bl==0){c=ct[bl];while(c<selt[bl]){
    tile0[c][0]=tile0[c+1][0];
    tile0[c][1]=tile0[c+1][1];
    tile0[c][2]=tile0[c+1][2];
    selt[bl]-=1;selt2-=1;ct[bl]=-1;c+=1;}c=0;}
  if(bl==1){c=ct[bl];while(c<selt[bl]){
    tile1[c][0]=tile1[c+1][0];
    tile1[c][1]=tile1[c+1][1];
    tile1[c][2]=tile1[c+1][2];
    selt[bl]-=1;selt2-=1;ct[bl]=-1;c+=1;}c=0;}
  if(bl==2){c=ct[bl];while(c<selt[bl]){
    tile2[c][0]=tile2[c+1][0];
    tile2[c][1]=tile2[c+1][1];
    tile2[c][2]=tile2[c+1][2];
    selt[bl]-=1;selt2-=1;ct[bl]=-1;c+=1;}c=0;}
  if(bl==3){c=ct[bl];while(c<selt[bl]){
    tile3[c][0]=tile3[c+1][0];
    tile3[c][1]=tile3[c+1][1];
    tile3[c][2]=tile3[c+1][2];
    selt[bl]-=1;selt2-=1;ct[bl]=-1;c+=1;}c=0;}
  if(bl==4){c=ct[bl];while(c<selt[bl]){
    tile4[c][0]=tile4[c+1][0];
    tile4[c][1]=tile4[c+1][1];
    tile4[c][2]=tile4[c+1][2];
    selt[bl]-=1;selt2-=1;ct[bl]=-1;c+=1;}c=0;}
  if(bl==5){c=ct[bl];while(c<selt[bl]){
    tile5[c][0]=tile5[c+1][0];
    tile5[c][1]=tile5[c+1][1];
    tile5[c][2]=tile5[c+1][2];
    selt[bl]-=1;selt2-=1;ct[bl]=-1;c+=1;}c=0;}
  if(bl==6){c=ct[bl];while(c<selt[bl]){
    tile6[c][0]=tile6[c+1][0];
    tile6[c][1]=tile6[c+1][1];
    tile6[c][2]=tile6[c+1][2];
    selt[bl]-=1;selt2-=1;ct[bl]=-1;c+=1;}c=0;}
  if(bl==7){c=ct[bl];while(c<selt[bl]){
    tile7[c][0]=tile7[c+1][0];
    tile7[c][1]=tile7[c+1][1];
    tile7[c][2]=tile7[c+1][2];
    selt[bl]-=1;selt2-=1;ct[bl]=-1;c+=1;}c=0;}
  if(bl==8){c=ct[bl];while(c<selt[bl]){
    tile8[c][0]=tile8[c+1][0];
    tile8[c][1]=tile8[c+1][1];
    tile8[c][2]=tile8[c+1][2];
    selt[bl]-=1;selt2-=1;ct[bl]=-1;c+=1;}c=0;}
  if(bl==9){c=ct[bl];while(c<selt[bl]){
    tile9[c][0]=tile9[c+1][0];
    tile9[c][1]=tile9[c+1][1];
    tile9[c][2]=tile9[c+1][2];
    selt[bl]-=1;selt2-=1;ct[bl]=-1;c+=1;}c=0;}
}mvd=0;







//:::::::::::::::::::::::::: SUPER SAVE.
if(ssaveh==1&&ssavehp==0){
  while(c<10){sectord[0][c][1]=0;c+=1;}c=0;
  while(d<2500){
    if(d<2499){sectord[d][0][1]=f;}
    while(e<selt[0]){
    if(tile0[e][3]==d){
     tiles[f+0]=tile0[e][0];
     tiles[f+1]=tile0[e][1];
     tiles[f+2]=tile0[e][2];
    f+=3;g+=1;}e+=1;}e=0;sectord[d][0][0]=g;g=0;
    if(d<2499){sectord[d][1][1]=f;}
    while(e<selt[1]){
    if(tile1[e][3]==d){
     tiles[f+0]=tile1[e][0];
     tiles[f+1]=tile1[e][1];
     tiles[f+2]=tile1[e][2];
    f+=3;g+=1;}e+=1;}e=0;sectord[d][1][0]=g;g=0;
    if(d<2499){sectord[d][2][1]=f;}
    while(e<selt[2]){
    if(tile2[e][3]==d){
     tiles[f+0]=tile2[e][0];
     tiles[f+1]=tile2[e][1];
     tiles[f+2]=tile2[e][2];
    f+=3;g+=1;}e+=1;}e=0;sectord[d][2][0]=g;g=0;
    if(d<2499){sectord[d][3][1]=f;}
    while(e<selt[3]){
    if(tile3[e][3]==d){
     tiles[f+0]=tile3[e][0];
     tiles[f+1]=tile3[e][1];
     tiles[f+2]=tile3[e][2];
    f+=3;g+=1;}e+=1;}e=0;sectord[d][3][0]=g;g=0;
    if(d<2499){sectord[d][4][1]=f;}
    while(e<selt[4]){
    if(tile4[e][3]==d){
     tiles[f+0]=tile4[e][0];
     tiles[f+1]=tile4[e][1];
     tiles[f+2]=tile4[e][2];
    f+=3;g+=1;}e+=1;}e=0;sectord[d][4][0]=g;g=0;
    if(d<2499){sectord[d][5][1]=f;}
    while(e<selt[5]){
    if(tile5[e][3]==d){
     tiles[f+0]=tile5[e][0];
     tiles[f+1]=tile5[e][1];
     tiles[f+2]=tile5[e][2];
    f+=3;g+=1;}e+=1;}e=0;sectord[d][5][0]=g;g=0;
    if(d<2499){sectord[d][6][1]=f;}
    while(e<selt[6]){
    if(tile6[e][3]==d){
     tiles[f+0]=tile6[e][0];
     tiles[f+1]=tile6[e][1];
     tiles[f+2]=tile6[e][2];
    f+=3;g+=1;}e+=1;}e=0;sectord[d][6][0]=g;g=0;
    if(d<2499){sectord[d][7][1]=f;}
    while(e<selt[7]){
    if(tile7[e][3]==d){
     tiles[f+0]=tile7[e][0];
     tiles[f+1]=tile7[e][1];
     tiles[f+2]=tile7[e][2];
    f+=3;g+=1;}e+=1;}e=0;sectord[d][7][0]=g;g=0;
    if(d<2499){sectord[d][8][1]=f;}
    while(e<selt[8]){
    if(tile8[e][3]==d){
     tiles[f+0]=tile8[e][0];
     tiles[f+1]=tile8[e][1];
     tiles[f+2]=tile8[e][2];
    f+=3;g+=1;}e+=1;}e=0;sectord[d][8][0]=g;g=0;
    if(d<2499){sectord[d][9][1]=f;}
    while(e<selt[9]){
    if(tile9[e][3]==d){
     tiles[f+0]=tile9[e][0];
     tiles[f+1]=tile9[e][1];
     tiles[f+2]=tile9[e][2];
    f+=3;g+=1;}e+=1;}e=0;sectord[d][9][0]=g;g=0;
   d+=1;}d=0;f=0;
  myfile.open ("map3s.txt");
  myfile<<  selt2  <<endl;
  while(c<10){
  myfile<<  selt[c]  <<endl;
  c+=1;}c=0;
  while(d<2500){while(e<10){
  myfile<<  sectord[d][e][0]  <<endl;
  myfile<<  sectord[d][e][1]  <<endl;
  e+=1;}e=0;d+=1;}d=0;
  while(c<9999){
  myfile<<  noldx[c]  <<endl;
  myfile<<  noldy[c]  <<endl;
  myfile<<  noldv[c][0]  <<endl;
  myfile<<  noldv[c][1]  <<endl;
  myfile<<  noldv[c][2]  <<endl;
  c+=1;}c=0;
  while(c<selt2*3){
  myfile<<  tiles[c]  <<endl;
  c+=1;}c=0;
/*  while(c<selt[1]){
  myfile<<  tile1[c][0]  <<endl;
  myfile<<  tile1[c][1]  <<endl;
  myfile<<  tile1[c][2]  <<endl;
  c+=1;}c=0;
  while(c<selt[2]){
  myfile<<  tile2[c][0]  <<endl;
  myfile<<  tile2[c][1]  <<endl;
  myfile<<  tile2[c][2]  <<endl;
  c+=1;}c=0;
  while(c<selt[3]){
  myfile<<  tile3[c][0]  <<endl;
  myfile<<  tile3[c][1]  <<endl;
  myfile<<  tile3[c][2]  <<endl;
  c+=1;}c=0;
  while(c<selt[4]){
  myfile<<  tile4[c][0]  <<endl;
  myfile<<  tile4[c][1]  <<endl;
  myfile<<  tile4[c][2]  <<endl;
  c+=1;}c=0;
  while(c<selt[5]){
  myfile<<  tile5[c][0]  <<endl;
  myfile<<  tile5[c][1]  <<endl;
  myfile<<  tile5[c][2]  <<endl;
  c+=1;}c=0;
  while(c<selt[6]){
  myfile<<  tile6[c][0]  <<endl;
  myfile<<  tile6[c][1]  <<endl;
  myfile<<  tile6[c][2]  <<endl;
  c+=1;}c=0;
  while(c<selt[7]){
  myfile<<  tile7[c][0]  <<endl;
  myfile<<  tile7[c][1]  <<endl;
  myfile<<  tile7[c][2]  <<endl;
  c+=1;}c=0;
  while(c<selt[8]){
  myfile<<  tile8[c][0]  <<endl;
  myfile<<  tile8[c][1]  <<endl;
  myfile<<  tile8[c][2]  <<endl;
  c+=1;}c=0;
  while(c<selt[9]){
  myfile<<  tile9[c][0]  <<endl;
  myfile<<  tile9[c][1]  <<endl;
  myfile<<  tile9[c][2]  <<endl;
  c+=1;}c=0;*/
  myfile.close();
cout<<"SUPER SAVED..."<<endl;ssavehp=1;}ssaveh=0;

//:::::::::::::::::::::::::: SAVE.
if(saveh==1&&savehp==0){
  myfile.open ("map3.txt");
  myfile<<  selt2  <<endl;
  while(c<10){
  myfile<<  selt[c]  <<endl;
  c+=1;}c=0;
  while(c<9999){
  myfile<<  noldx[c]  <<endl;
  myfile<<  noldy[c]  <<endl;
  myfile<<  noldv[c][0]  <<endl;
  myfile<<  noldv[c][1]  <<endl;
  myfile<<  noldv[c][2]  <<endl;
  c+=1;}c=0;
  while(c<selt[0]){
  myfile<<  tile0[c][0]  <<endl;
  myfile<<  tile0[c][1]  <<endl;
  myfile<<  tile0[c][2]  <<endl;
  myfile<<  tile0[c][3]  <<endl;
  c+=1;}c=0;
  while(c<selt[1]){
  myfile<<  tile1[c][0]  <<endl;
  myfile<<  tile1[c][1]  <<endl;
  myfile<<  tile1[c][2]  <<endl;
  myfile<<  tile1[c][3]  <<endl;
  c+=1;}c=0;
  while(c<selt[2]){
  myfile<<  tile2[c][0]  <<endl;
  myfile<<  tile2[c][1]  <<endl;
  myfile<<  tile2[c][2]  <<endl;
  myfile<<  tile2[c][3]  <<endl;
  c+=1;}c=0;
  while(c<selt[3]){
  myfile<<  tile3[c][0]  <<endl;
  myfile<<  tile3[c][1]  <<endl;
  myfile<<  tile3[c][2]  <<endl;
  myfile<<  tile3[c][3]  <<endl;
  c+=1;}c=0;
  while(c<selt[4]){
  myfile<<  tile4[c][0]  <<endl;
  myfile<<  tile4[c][1]  <<endl;
  myfile<<  tile4[c][2]  <<endl;
  myfile<<  tile4[c][3]  <<endl;
  c+=1;}c=0;
  while(c<selt[5]){
  myfile<<  tile5[c][0]  <<endl;
  myfile<<  tile5[c][1]  <<endl;
  myfile<<  tile5[c][2]  <<endl;
  myfile<<  tile5[c][3]  <<endl;
  c+=1;}c=0;
  while(c<selt[6]){
  myfile<<  tile6[c][0]  <<endl;
  myfile<<  tile6[c][1]  <<endl;
  myfile<<  tile6[c][2]  <<endl;
  myfile<<  tile6[c][3]  <<endl;
  c+=1;}c=0;
  while(c<selt[7]){
  myfile<<  tile7[c][0]  <<endl;
  myfile<<  tile7[c][1]  <<endl;
  myfile<<  tile7[c][2]  <<endl;
  myfile<<  tile7[c][3]  <<endl;
  c+=1;}c=0;
  while(c<selt[8]){
  myfile<<  tile8[c][0]  <<endl;
  myfile<<  tile8[c][1]  <<endl;
  myfile<<  tile8[c][2]  <<endl;
  myfile<<  tile8[c][3]  <<endl;
  c+=1;}c=0;
  while(c<selt[9]){
  myfile<<  tile9[c][0]  <<endl;
  myfile<<  tile9[c][1]  <<endl;
  myfile<<  tile9[c][2]  <<endl;
  myfile<<  tile9[c][3]  <<endl;
  c+=1;}c=0;
  myfile.close();
cout<<"SAVED..."<<endl;savehp=1;}saveh=0;

//:::::::::::::::::::::::::: LOAD.
if(loadh==1&&loadhp==0){
  myfile.open ("map3.txt");
  myfile>>  selt2;
  while(c<10){
  myfile>>  selt[c];
  c+=1;}c=0;
  while(c<9999){
  myfile>>  noldx[c];
  myfile>>  noldy[c];
  myfile>>  noldv[c][0];
  myfile>>  noldv[c][1];
  myfile>>  noldv[c][2];
  c+=1;}c=0;
  while(c<selt[0]){
  myfile>>  tile0[c][0];
  myfile>>  tile0[c][1];
  myfile>>  tile0[c][2];
  myfile>>  tile0[c][3];
  c+=1;}c=0;
  while(c<selt[1]){
  myfile>>  tile1[c][0];
  myfile>>  tile1[c][1];
  myfile>>  tile1[c][2];
  myfile>>  tile1[c][3];
  c+=1;}c=0;
  while(c<selt[2]){
  myfile>>  tile2[c][0];
  myfile>>  tile2[c][1];
  myfile>>  tile2[c][2];
  myfile>>  tile2[c][3];
  c+=1;}c=0;
  while(c<selt[3]){
  myfile>>  tile3[c][0];
  myfile>>  tile3[c][1];
  myfile>>  tile3[c][2];
  myfile>>  tile3[c][3];
  c+=1;}c=0;
  while(c<selt[4]){
  myfile>>  tile4[c][0];
  myfile>>  tile4[c][1];
  myfile>>  tile4[c][2];
  myfile>>  tile4[c][3];
  c+=1;}c=0;
  while(c<selt[5]){
  myfile>>  tile5[c][0];
  myfile>>  tile5[c][1];
  myfile>>  tile5[c][2];
  myfile>>  tile5[c][3];
  c+=1;}c=0;
  while(c<selt[6]){
  myfile>>  tile6[c][0];
  myfile>>  tile6[c][1];
  myfile>>  tile6[c][2];
  myfile>>  tile6[c][3];
  c+=1;}c=0;
  while(c<selt[7]){
  myfile>>  tile7[c][0];
  myfile>>  tile7[c][1];
  myfile>>  tile7[c][2];
  myfile>>  tile7[c][3];
  c+=1;}c=0;
  while(c<selt[8]){
  myfile>>  tile8[c][0];
  myfile>>  tile8[c][1];
  myfile>>  tile8[c][2];
  myfile>>  tile8[c][3];
  c+=1;}c=0;
  while(c<selt[9]){
  myfile>>  tile9[c][0];
  myfile>>  tile9[c][1];
  myfile>>  tile9[c][2];
  myfile>>  tile9[c][3];
  c+=1;}c=0;
  myfile.close();
/*  myfile.open ("map3.txt");
  myfile>>  selt2;
  while(c<10){
  myfile>>  selt[c];
  c+=1;}c=0;
  while(c<9999){
  myfile>>  noldx[c];
  myfile>>  noldy[c];
  myfile>>  noldv[c][0];
  myfile>>  noldv[c][1];
  myfile>>  noldv[c][2];
  c+=1;}c=0;
  while(c<selt[0]){
  myfile>>  tile0[c][0];
  myfile>>  tile0[c][1];
  myfile>>  tile0[c][2];
  myfile>>  tile0[c][3];
  myfile>>  tile0[c][4];
  c+=1;}c=0;
  while(c<selt[1]){
  myfile>>  tile1[c][0];
  myfile>>  tile1[c][1];
  myfile>>  tile1[c][2];
  myfile>>  tile1[c][3];
  myfile>>  tile1[c][4];
  c+=1;}c=0;
  while(c<selt[2]){
  myfile>>  tile2[c][0];
  myfile>>  tile2[c][1];
  myfile>>  tile2[c][2];
  myfile>>  tile2[c][3];
  myfile>>  tile2[c][4];
  c+=1;}c=0;
  while(c<selt[3]){
  myfile>>  tile3[c][0];
  myfile>>  tile3[c][1];
  myfile>>  tile3[c][2];
  myfile>>  tile3[c][3];
  myfile>>  tile3[c][4];
  c+=1;}c=0;
  while(c<selt[4]){
  myfile>>  tile4[c][0];
  myfile>>  tile4[c][1];
  myfile>>  tile4[c][2];
  myfile>>  tile4[c][3];
  myfile>>  tile4[c][4];
  c+=1;}c=0;
  while(c<selt[5]){
  myfile>>  tile5[c][0];
  myfile>>  tile5[c][1];
  myfile>>  tile5[c][2];
  myfile>>  tile5[c][3];
  myfile>>  tile5[c][4];
  c+=1;}c=0;
  while(c<selt[6]){
  myfile>>  tile6[c][0];
  myfile>>  tile6[c][1];
  myfile>>  tile6[c][2];
  myfile>>  tile6[c][3];
  myfile>>  tile6[c][4];
  c+=1;}c=0;
  while(c<selt[7]){
  myfile>>  tile7[c][0];
  myfile>>  tile7[c][1];
  myfile>>  tile7[c][2];
  myfile>>  tile7[c][3];
  myfile>>  tile7[c][4];
  c+=1;}c=0;
  while(c<selt[8]){
  myfile>>  tile8[c][0];
  myfile>>  tile8[c][1];
  myfile>>  tile8[c][2];
  myfile>>  tile8[c][3];
  myfile>>  tile8[c][4];
  c+=1;}c=0;
  while(c<selt[9]){
  myfile>>  tile9[c][0];
  myfile>>  tile9[c][1];
  myfile>>  tile9[c][2];
  myfile>>  tile9[c][3];
  myfile>>  tile9[c][4];
  c+=1;}c=0;
  myfile.close();*/
cout<<"LOADED..."<<endl;loadhp=1;}loadh=0;


//********************************************************************************************* RENDER.
// DRAW TILE MAP.
// make link[2500][5][505] last 5 is number of tiles on layer
//to optimize, if [4]==d -> if [3] > X < X | >X50 | >X-50


while(c<selt2){
 if(tile0[c][0]!=-999){
 eX=(tile0[c][0]-screen_layer[0][0])*pixel_to_gl_X;eY=(tile0[c][1]-screen_layer[0][1])*pixel_to_gl_Y;
 if(eX>=-2.0&&eX<=2.0&&eY>=-2.0&&eY<=2.0){
  if(bl==0){alph=1.0;}else{alph=0.25;}if(ct[0]==c){colt=0.2;}else{colt=1.0;}
  draw2(eX,eY,w[tile0[c][2]],h[tile0[c][2]],tile0[c][2],1.0,0.0,1.0,colt,colt,alph,-1-d);d+=1;}}
 if(tile1[c][0]!=-999){
 eX=(tile1[c][0]-screen_layer[1][0])*pixel_to_gl_X;eY=(tile1[c][1]-screen_layer[1][1])*pixel_to_gl_Y;
 if(eX>=-2.0&&eX<=2.0&&eY>=-2.0&&eY<=2.0){
  if(bl==1){alph=1.0;}else{alph=0.25;}if(ct[1]==c){colt=0.2;}else{colt=1.0;}
  draw2(eX,eY,w[tile1[c][2]],h[tile1[c][2]],tile1[c][2],1.0,0.0,1.0,colt,colt,alph,-1-d);d+=1;}}
 if(tile2[c][0]!=-999){
 eX=(tile2[c][0]-screen_layer[2][0])*pixel_to_gl_X;eY=(tile2[c][1]-screen_layer[2][1])*pixel_to_gl_Y;
 if(eX>=-2.0&&eX<=2.0&&eY>=-2.0&&eY<=2.0){
  if(bl==2){alph=1.0;}else{alph=0.25;}if(ct[2]==c){colt=0.2;}else{colt=1.0;}
  draw2(eX,eY,w[tile2[c][2]],h[tile2[c][2]],tile2[c][2],1.0,0.0,1.0,colt,colt,alph,-1-d);d+=1;}}
 if(tile3[c][0]!=-999){
 eX=(tile3[c][0]-screen_layer[3][0])*pixel_to_gl_X;eY=(tile3[c][1]-screen_layer[3][1])*pixel_to_gl_Y;
 if(eX>=-2.0&&eX<=2.0&&eY>=-2.0&&eY<=2.0){
  if(bl==3){alph=1.0;}else{alph=0.25;}if(ct[3]==c){colt=0.2;}else{colt=1.0;}
  draw2(eX,eY,w[tile3[c][2]],h[tile3[c][2]],tile3[c][2],1.0,0.0,1.0,colt,colt,alph,-1-d);d+=1;}}
 if(tile4[c][0]!=-999){
 eX=(tile4[c][0]-screen_layer[4][0])*pixel_to_gl_X;eY=(tile4[c][1]-screen_layer[4][1])*pixel_to_gl_Y;
 if(eX>=-2.0&&eX<=2.0&&eY>=-2.0&&eY<=2.0){
  if(bl==4){alph=1.0;}else{alph=0.25;}if(ct[4]==c){colt=0.2;}else{colt=1.0;}
  draw2(eX,eY,w[tile4[c][2]],h[tile4[c][2]],tile4[c][2],1.0,0.0,1.0,colt,colt,alph,-1-d);d+=1;}}
 if(tile5[c][0]!=-999){
 eX=(tile5[c][0]-screen_layer[5][0])*pixel_to_gl_X;eY=(tile5[c][1]-screen_layer[5][1])*pixel_to_gl_Y;
 if(eX>=-2.0&&eX<=2.0&&eY>=-2.0&&eY<=2.0){
  if(bl==5){alph=1.0;}else{alph=0.25;}if(ct[5]==c){colt=0.2;}else{colt=1.0;}
  draw2(eX,eY,w[tile5[c][2]],h[tile5[c][2]],tile5[c][2],1.0,0.0,1.0,colt,colt,alph,-1-d);d+=1;}}
 if(tile6[c][0]!=-999){
 eX=(tile6[c][0]-screen_layer[6][0])*pixel_to_gl_X;eY=(tile6[c][1]-screen_layer[6][1])*pixel_to_gl_Y;
 if(eX>=-2.0&&eX<=2.0&&eY>=-2.0&&eY<=2.0){
  if(bl==6){alph=1.0;}else{alph=0.25;}if(ct[6]==c){colt=0.2;}else{colt=1.0;}
  draw2(eX,eY,w[tile6[c][2]],h[tile6[c][2]],tile6[c][2],1.0,0.0,1.0,colt,colt,alph,-1-d);d+=1;}}
 if(tile7[c][0]!=-999){
 eX=(tile7[c][0]-screen_layer[7][0])*pixel_to_gl_X;eY=(tile7[c][1]-screen_layer[7][1])*pixel_to_gl_Y;
 if(eX>=-2.0&&eX<=2.0&&eY>=-2.0&&eY<=2.0){
  if(bl==7){alph=1.0;}else{alph=0.25;}if(ct[7]==c){colt=0.2;}else{colt=1.0;}
  draw2(eX,eY,w[tile7[c][2]],h[tile7[c][2]],tile7[c][2],1.0,0.0,1.0,colt,colt,alph,-1-d);d+=1;}}
 if(tile8[c][0]!=-999){
 eX=(tile8[c][0]-screen_layer[8][0])*pixel_to_gl_X;eY=(tile8[c][1]-screen_layer[8][1])*pixel_to_gl_Y;
 if(eX>=-2.0&&eX<=2.0&&eY>=-2.0&&eY<=2.0){
  if(bl==8){alph=1.0;}else{alph=0.25;}if(ct[8]==c){colt=0.2;}else{colt=1.0;}
  draw2(eX,eY,w[tile8[c][2]],h[tile8[c][2]],tile8[c][2],1.0,0.0,1.0,colt,colt,alph,-1-d);d+=1;}}
 if(tile9[c][0]!=-999){
 eX=(tile9[c][0]-screen_layer[9][0])*pixel_to_gl_X;eY=(tile9[c][1]-screen_layer[9][1])*pixel_to_gl_Y;
 if(eX>=-2.0&&eX<=2.0&&eY>=-2.0&&eY<=2.0){
  if(bl==9){alph=1.0;}else{alph=0.25;}if(ct[9]==c){colt=0.2;}else{colt=1.0;}
  draw2(eX,eY,w[tile9[c][2]],h[tile9[c][2]],tile9[c][2],1.0,0.0,1.0,colt,colt,alph,-1-d);d+=1;}}
c+=1;}c=0;d=0;


/*while(d<10){if(d==bl){alph=1.0;}else{alph=0.25;}while(c<selt2){
  if(tile[c][3]==choosed2&&chooset==c){colt=0.2;}else{colt=1.0;}
  if(tile[c][3]>=eds[d]-1&&tile[c][3]<=eds[d]+1&&tile[c][4]==d){
  eX=(tile[c][0]-screen_layer[d][0])*pixel_to_gl_X;eY=(tile[c][1]-screen_layer[d][1])*pixel_to_gl_Y;
  draw2(eX,eY,w[tile[c][2]],h[tile[c][2]],tile[c][2],1.0,0.0,1.0,colt,colt,alph,-1-c-(d*1000));}
c+=1;}c=0;d+=1;}d=0;
while(d<5){if(d==bl){alph=1.0;}else{alph=0.25;}while(c<selt2){
  if(tile[c][3]==choosed2&&chooset==c){colt=0.2;}else{colt=1.0;}
  if(tile[c][3]>=eds[d]-51&&tile[c][3]<=eds[d]-49&&tile[c][4]==d){
  eX=(tile[c][0]-screen_layer[d][0])*pixel_to_gl_X;eY=(tile[c][1]-screen_layer[d][1])*pixel_to_gl_Y;
  draw2(eX,eY,w[tile[c][2]],h[tile[c][2]],tile[c][2],1.0,0.0,1.0,colt,colt,alph,-1-c-(d*1000));}
c+=1;}c=0;d+=1;}d=0;
while(d<5){if(d==bl){alph=1.0;}else{alph=0.25;}while(c<selt2){
  if(tile[c][3]==choosed2&&chooset==c){colt=0.2;}else{colt=1.0;}
  if(tile[c][3]>=eds[d]+49&&tile[c][3]<=eds[d]+51&&tile[c][4]==d){
  eX=(tile[c][0]-screen_layer[d][0])*pixel_to_gl_X;eY=(tile[c][1]-screen_layer[d][1])*pixel_to_gl_Y;
  draw2(eX,eY,w[tile[c][2]],h[tile[c][2]],tile[c][2],1.0,0.0,1.0,colt,colt,alph,-1-c-(d*1000));}
c+=1;}c=0;d+=1;}d=0;*/
/*while(d<5){if(d==bl){alph=1.0;}else{alph=0.25;}while(c<selt[ed+1][d]){
  if(c==chooset&&choosed==ed+1){colt=0.2;}else{colt=1.0;}
  eX=(tile[ed+1][d][c][0]-scrX)*pixel_to_gl_X;eY=(tile[ed+1][d][c][1]-scrY)*pixel_to_gl_Y;
  draw2(eX,eY,w[tile[ed][d][c][2]],h[tile[ed][d][c][2]],tile[ed][d][c][2],1.0,0.0,1.0,colt,colt,alph,-1-c-(d*1000));
c+=1;}c=0;d+=1;}d=0;
while(d<5){if(d==bl){alph=1.0;}else{alph=0.25;}while(c<selt[ed+50][d]){
  if(c==chooset&&choosed==ed+50){colt=0.2;}else{colt=1.0;}
  eX=(tile[ed+50][d][c][0]-scrX)*pixel_to_gl_X;eY=(tile[ed+50][d][c][1]-scrY)*pixel_to_gl_Y;
  draw2(eX,eY,w[tile[ed][d][c][2]],h[tile[ed][d][c][2]],tile[ed][d][c][2],1.0,0.0,1.0,colt,colt,alph,-1-c-(d*1000));
c+=1;}c=0;d+=1;}d=0;
while(d<5){if(d==bl){alph=1.0;}else{alph=0.25;}while(c<selt[ed+51][d]){
  if(c==chooset&&choosed==ed+51){colt=0.2;}else{colt=1.0;}
  eX=(tile[ed+51][d][c][0]-scrX)*pixel_to_gl_X;eY=(tile[ed+51][d][c][1]-scrY)*pixel_to_gl_Y;
  draw2(eX,eY,w[tile[ed][d][c][2]],h[tile[ed][d][c][2]],tile[ed][d][c][2],1.0,0.0,1.0,colt,colt,alph,-1-c-(d*1000));
c+=1;}c=0;d+=1;}d=0;*/

// DRAW NODES.
while(c<9999){if(noldx[c]!=0||noldy[c]!=0){
  eX=(noldx[c]-400-scrX)*pixel_to_gl_X;eY=(noldy[c]-240-scrY)*pixel_to_gl_Y;
  if(c==sn){draw2(eX,eY,w[node],h[node],node,1.0,0.0,1.0,1.0,1.0,1.0,-840000-c);}
else{draw2(eX,eY,w[node],h[node],node,1.0,0.0,1.0,1.0,1.0,0.5,-840000-c);}
   if(noldx[c+1]!=0&&noldy[c+1]!=0){
   glDisableClientState(GL_TEXTURE_COORD_ARRAY);
   vd[0]=(noldx[c]-400-scrX)*pixel_to_gl_X;vd[1]=(noldy[c]-240-noldv[c][0]-scrY)*pixel_to_gl_Y;
   vd[2]=-890000-c;
   vd[3]=(noldx[c+1]-400-scrX)*pixel_to_gl_X;vd[4]=(noldy[c+1]-240-noldv[c+1][0]-scrY)*pixel_to_gl_Y;
   vd[5]=-890000-c;
   vd[6]=(noldx[c]-400-scrX)*pixel_to_gl_X;vd[7]=(noldy[c]-240-scrY)*pixel_to_gl_Y;
   vd[8]=-890000-c;
   vd[9]=(noldx[c+1]-400-scrX)*pixel_to_gl_X;vd[10]=(noldy[c+1]-240-scrY)*pixel_to_gl_Y;
   vd[11]=-890000-c;
   vd[12]=(noldx[c]-400-scrX)*pixel_to_gl_X;vd[13]=(noldy[c]-240+noldv[c][1]-scrY)*pixel_to_gl_Y;
   vd[14]=-890000-c;
   vd[15]=(noldx[c+1]-400-scrX)*pixel_to_gl_X;vd[16]=(noldy[c+1]-240+noldv[c+1][1]-scrY)*pixel_to_gl_Y;
   vd[17]=-890000-c;
   cd[0]=0.0; cd[1]=1.0; cd[2]=0.0; cd[3]=1.0;
   cd[4]=0.0; cd[5]=1.0; cd[6]=0.0; cd[7]=1.0;
   cd[8]=1.0; cd[9]=1.0; cd[10]=1.0;cd[11]=1.0;
   cd[12]=1.0;cd[13]=1.0;cd[14]=1.0;cd[15]=1.0;
   cd[16]=1.0;cd[17]=1.0;cd[18]=0.0;cd[19]=1.0;
   cd[20]=1.0;cd[21]=1.0;cd[22]=0.0;cd[23]=1.0;
  glColorPointer(4,GL_FLOAT,0,cd);
  glVertexPointer(3,GL_FLOAT,0,vd);
  glDrawArrays(GL_LINES,0,6);
   glEnableClientState(GL_TEXTURE_COORD_ARRAY);}
}c+=1;}c=0;

// DRAW MOLD.
eX=(moldx-400)*pixel_to_gl_X;eY=(moldy-240)*pixel_to_gl_Y;
draw2(eX,eY,w[moldt],h[moldt],moldt,1.0,0.0,1.0,1.0,1.0,0.75,-900000);
//while(c<99999){draw2(eX,eY,w[node],h[node],node,1.0,0.0,1.0,1.0,1.0,0.75,-900000);c+=1;}c=0;
SDL_GL_SwapBuffers();
glClear(GL_COLOR_BUFFER_BIT);


currentTime=SDL_GetTicks();
if(currentTime-oldTime<framerate)
{SDL_Delay(framerate-(currentTime-oldTime));}
oldTime=SDL_GetTicks();}//*********************************************** END OF GAME LOOP

 free_textures();
 glDisableClientState(GL_VERTEX_ARRAY);
 glDisableClientState(GL_TEXTURE_COORD_ARRAY);
 glDisableClientState(GL_COLOR_ARRAY);
SDL_Quit();

    return 0;
}
